// @Author: Ulrich Schregenberger
// @Version: 1.0
// @Release Date: 01/04/2008

import java.io.*;

import javax.swing.event.*;
import javax.swing.*;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;
import javax.swing.text.AttributeSet;

import java.nio.*;
import java.nio.channels.*;

import java.util.*;
import java.util.List;
import java.awt.*;
import java.awt.event.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;

import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;

import org.blinkenlights.jid3.*;
import org.blinkenlights.jid3.v1.*;
import org.blinkenlights.jid3.v2.*;

import com.pagosoft.plaf.themes.*;
import com.pagosoft.plaf.*;
import com.pagosoft.swing.*;
import com.pagosoft.*;

import org.apache.log4j.*;



public class CopyOfTouch5 extends JFrame implements DropTargetListener
{
	
	
	private static Logger logger = Logger.getRootLogger();
		
	String label;
	int i;
	File[] files3;
	File[] files2;
	File[] files;
	String[] namen;
	String[] namemp3;
	String[] namemp3temp;
	String[] reloader;
	
	String[] undo1;
	String[] undo2;
		
	JComboBox cbx1; 
	ComboBoxModel cbxm1;
	ComboBoxModel cbxm2;
	JPanel panel1;
	JPanel panel2;
	JPanel panel3;
	JPanel panel3a;
	JPanel panel3b;
	
	JPanel panel4;
	JButton button1;
	JButton button111;
	JButton button2;
	JButton button3;
	JButton button4;
	JButton button5;
	JButton button6;
	JButton button7;
	JButton button8;
	JButton button999;
	JButton button11;
	JButton button12;
	JButton button13;
	JButton button14;
	JTextArea info;
	
	MouseListener ml;
	JTextField artistfield;
	JButton artistprev;
	
	
	// schalter fr das: nachdem go gedrckt worden ist, sollen alle anderen schaltflchen nichts mehr tun bis
	// a) entweder RELOAD gemacht wurde
	// b) oder CLEAR
	int nachgo = 0;
	
	
	JButton clearsel;
	
	JButton button10;
	
	int renamecounter = 0;
	
	int switchnurid = 0;
	 
	DropTarget dt;
	private static final String URI_LIST_MIME_TYPE = "text/uri-list;class=java.lang.String";
	
	JRadioButtonMenuItem rb1;
	JRadioButtonMenuItem rb2;
	ButtonGroup bg;
	
	JRadioButton deli1;
	JRadioButton deli2;
	ButtonGroup delig;
	
	JRadioButton rb11;
	JRadioButton rb22;
	JRadioButton rb33;
	ButtonGroup bg2;
	
	JButton emergency; // globaler emergency stop button
	int kanzler = 0; // prfbit fr emergency stop
	
	JRadioButton rb111,rb222,rb333,rb444;
	ButtonGroup bg3;
	JCheckBox tag1,tag2;
	
	int umschalter = 1; // Sachalter wird mit 1 initialisiert beim start; 1 = Simple mode; 2 = ID3 mode
		
	JRadioButton deltags;
	JCheckBox deltag1,deltag2;
	
	StyledDocument doc,doc2;
	JScrollPane scrollPane,scrollPane2;
	Style def,s,s2,s3,s4,s5,def2;
	JPanel panel;
	
	JCheckBoxMenuItem helper;
		
	JButton dashrenamer,garfield1,garfield2;
	
	ItemEvent e;
	JTabbedPane tabpane;
	
	ItemEvent mpe;
	
	JList dateiliste;
	JList dateiliste2;
	JList pfadliste;
	Vector listenvektor = new Vector();
	Vector listenvektor2 = new Vector();
	Vector dateipfad = new Vector();
	int listengroesse=0;
	
	JPanel gridbagpanel;
	
	ListItem[] li;
	DefaultListModel farbmodel;
	Color col1 = Color.WHITE;
	Color col2 = new Color(123,255,71);
	Color col3 = new Color(255,197,84);
	Color col4 = new Color(255,197,84); // orange ist besser als rot
	Color col5 = new Color(255,255,64);
	Color col6 = Color.red;
	
	JLabel counterlab;
	static JProgressBar progress;
	
	int minValue = 0;
	int maxValue = 100;
	static int counter = 1; // gilt nur fr die % anzeige beim balken, muss bei 1 beginnen, damit auf 100% kommt
	static int z = 0;		// iterator innherhalb der threads fr funktionen
	int threadit;
	static int q;
	int threadit2;
	static int counter2 = 1;
	static int pos3;
	
	
	MouseInputListener mil2;
	public String dialogtempfile;
	
	JCheckBox item2a;
	JCheckBoxMenuItem item2b;
	JCheckBoxMenuItem item2c;	
	
	JCheckBoxMenuItem item3a;
	JCheckBoxMenuItem item3b;
	JCheckBoxMenuItem item3c;	
	
	JButton eins,zwo,drei,vier,trimmer;
	
	MouseListener Maus2;
	
	ItemEvent rmod;
	ItemEvent einszwodrei;
	JSplitPane bo;
	JScrollPane scroller,scroller2,scrollertemp;
	
	GridBagConstraints c;
	final int x = 110; // hhe fr infotextpanel
	ItemEvent help;
	
	JPanel panelX;
	
	int infoindex = 1;
	 
	AquaButtonPanel buttonRELOAD;
	AquaButtonPanel buttonEXE;
	AquaButtonPanel button99;
	
	JButton buttonRES,rem,undo,redo;
	
	Vector keller = new Vector();
	int pos;
	int max;
	
	Color r = new Color(208,0,0);//rot
	Color g = Color.GREEN;	
	Color b = new Color(0,128,255);
	Color dr = new Color(255,0,0);//dunkelrot
	Color dg = new Color(92,255,0);
	Color db = new Color(0,172,255);
	Color hr = new Color(255,64,64);//hellrot
	Color hg = new Color(64,255,64);
	Color hb = new Color(64,64,255);
	
	// GUI
	public CopyOfTouch5()
	{
		try
		{
			SimpleLayout layout = new SimpleLayout();
			ConsoleAppender consoleAppender = new ConsoleAppender(layout);
			logger.addAppender(consoleAppender);
			//FileAppender fileAppender = new FileAppender(layout,"TouchMP3.log",true);
			//logger.addAppender(fileAppender);
			
			// ALL | DEBUG | INFO | WARN | ERROR | FATAL | OFF:
			logger.setLevel(Level.OFF);
		}
		catch(Exception logex){}
		
		JMenuBar menueleiste = new JMenuBar();
		menueleiste.setPreferredSize(new Dimension(800,25));
		
		//getContentPane().setBackground(Color.CYAN);	
		
		JMenu menu1 = new JMenu("File");
		JMenuItem item1b = new JMenuItem("Exit");
		item1b.addActionListener(new Actlist());
		menu1.add(item1b);		
		
		JMenu menu2 = new JMenu("Settings");
		
		rb1 = new JRadioButtonMenuItem("Skip");
		rb2 = new JRadioButtonMenuItem("Flag");
		rb2.setSelected(true);
		bg = new ButtonGroup();
		bg.add(rb1);
		bg.add(rb2);
		rb1.addItemListener(ItemList);
		rb2.addItemListener(ItemList);		
		menu2.add(rb1);
		menu2.add(rb2);
		
		menu2.addSeparator();
		
		item2c = new JCheckBoxMenuItem ("1-Time D&D");	// fr 1-Time Drops, deativiert continuous mode
		item2c.addItemListener(optionlistener);	
		menu2.add(item2c);
		
		menu2.addSeparator();
		
		item3a = new JCheckBoxMenuItem ("Underscores");	// underscores
		item3b = new JCheckBoxMenuItem ("Whitespaces");	// whitespaces
		item3c = new JCheckBoxMenuItem ("Quotes");	// quotes
		item3a.addItemListener(listener123);
		item3b.addItemListener(listener123);
		item3c.addItemListener(listener123);
		item3a.setSelected(true);
		item3b.setSelected(true);
		item3c.setSelected(true);
		menu2.add(item3a);
		menu2.add(item3b);
		menu2.add(item3c);
		
		JMenu menu3 = new JMenu("?");
		helper = new JCheckBoxMenuItem("Help",true);
		helper.setSelected(false);
	    helper.addItemListener(helperlistener);
	    menu3.add(helper);
		JMenuItem item3b = new JMenuItem("About");
		item3b.addActionListener(new Actlist());
		menu3.add(item3b);
				
		menueleiste.add(menu1);
		menueleiste.add(menu2);
		menueleiste.add(menu3);
		setJMenuBar(menueleiste);
		
		ClassLoader cls0 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL url0 = cls0.getResource("reset.png"); // icon must be in /src and /bin
		ImageIcon icon0 = new ImageIcon(url0);
		
		ClassLoader cls1 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL url1 = cls1.getResource("remove.png"); // icon must be in /src and /bin
		ImageIcon icon1 = new ImageIcon(url1);
		
		ClassLoader cls2 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL url2 = cls2.getResource("undo.png"); // icon must be in /src and /bin
		ImageIcon icon2 = new ImageIcon(url2);
		
		ClassLoader cls3 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL url3 = cls3.getResource("redo.png"); // icon must be in /src and /bin
		ImageIcon icon3 = new ImageIcon(url3);	
		
		ClassLoader cls4 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL url4 = cls4.getResource("clear.png"); // icon must be in /src and /bin
		ImageIcon icon4 = new ImageIcon(url4);
		
		ClassLoader cls5 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL url5 = cls5.getResource("stop.png"); // icon must be in /src and /bin
		ImageIcon icon5 = new ImageIcon(url5);
		
		// ToolBar und Buttons
		buttonRES = new JButton("RESET",icon0);
		clearsel = new JButton("CL SEL",icon4);
		buttonRES.addActionListener(new Actlist3());
		clearsel.addActionListener(new Actlist());
		
		emergency = new JButton("STOP",icon5);emergency.setEnabled(false);
		rem = new JButton(icon1);
		undo = new JButton(icon2);
		redo = new JButton(icon3);
		
		rem.setActionCommand("rem");
		undo.setActionCommand("undo");
		redo.setActionCommand("redo");
		emergency.addActionListener(new KanzlerListener());
		rem.addActionListener(new ActionListenerX());
		undo.addActionListener(new ActionListenerX());
		redo.addActionListener(new ActionListenerX());
		
		JToolBar toolbar = new JToolBar();
		toolbar.setPreferredSize(new Dimension(400,30));
		toolbar.setFloatable(false);
		
		toolbar.setComponentOrientation(ComponentOrientation.LEFT_TO_RIGHT);
		
		toolbar.add(undo);
		toolbar.add(redo);
		toolbar.add(buttonRES);
		toolbar.add(clearsel);
		toolbar.add(rem);
		toolbar.add(emergency);
		
		
		
		
		
		panel1 = new JPanel();
		panel2 = new JPanel();
		panel3 = new JPanel();
		panel4 = new JPanel();
			
		eins = new JButton("lowerC");
		zwo = new JButton("upperC");
		drei = new JButton("Number");
		trimmer = new JButton("Trimmer");
		vier = new JButton("\"-\" to \" - \"");
		
		eins.addActionListener(new FunctionListener());
		zwo.addActionListener(new FunctionListener());
		drei.addActionListener(new FunctionListener());
		trimmer.addActionListener(new FunctionListener());
		vier.addActionListener(new FunctionListener());
		
		button1 = new JButton("L");
		button111 = new JButton("R");
		
		button4 = new JButton("Swap");
		
		
		
		
		dateiliste = new JList();
		
		farbmodel = new DefaultListModel();
		dateiliste2 = new JList(farbmodel);
		dateiliste2.setCellRenderer(new MyCellRenderer());
		
		scroller = new JScrollPane(dateiliste);
		scroller2 = new JScrollPane(dateiliste2);
		
		
		mil2 = new dragSelectionListener();
		
		// fge die dateiliste2 zu einem mouselistener dazu fr popupmen
		
		Maus2 = new MouseAdapter()
		{
			public void mouseClicked(MouseEvent arg0) 
			{
				// soll bei doppelklick ein popup erstellen
				if((arg0.getButton() == 1) && (arg0.getClickCount()==2))	// bei doppelklick
				{		
					if(nachgo == 1)
					{
						Toolkit.getDefaultToolkit().beep();
						JOptionPane.showMessageDialog(null,
								"You must either RELOAD the changed files first or CLEAR the filelist\n" +
								"in order to continue working!",
							    "Error",
							    JOptionPane.ERROR_MESSAGE);
					}			
					else
					{
						Object selected = dateiliste2.getSelectedValue();	
						int e_index = (int) farbmodel.indexOf(selected); // bestimme die position, wo doppelgeklickt wird
						
						
							if(e_index != -1) // sofern nicht ins leere (-1) geklickt wird...
							{
								ListItem e_li = (ListItem) farbmodel.getElementAt(e_index);	// hole ListItem an entsprechendem Index
								String e_string = e_li.getValue();		// Wert in ListItem auslesen und in e_string speichern
								
								
								String e_ditedname = (String) JOptionPane.showInputDialog(null,
																				e_string,
																				"Change Filename",
																				JOptionPane.WARNING_MESSAGE,
																				null,
																				null,
																				e_string);
								if((e_ditedname != null)&&(!e_ditedname.equals("")))
								{
									//System.out.println("New name is: "+e_ditedname);
									farbmodel.setElementAt(new ListItem(col1,e_ditedname),e_index);
									
									// man muss den vernderten namen in namen[i] noch eintragen
									for(int i=0;i<listenvektor.size();i++)
									{
										namen[e_index] = e_ditedname;
									}
								}
								else
								{
									//System.out.println("Name remains: "+e_string);
								}
							}
					}
					
				}
			}
			
			public void mousePressed(MouseEvent arg0)
			{
				
					if(arg0.getButton() == 3)	// bei rechtsklick
					{
						if(nachgo == 1)
						{
							Toolkit.getDefaultToolkit().beep();
							JOptionPane.showMessageDialog(null,
									"You must either RELOAD the changed files first or CLEAR the filelist\n" +
									"in order to continue working!",
								    "Error",
								    JOptionPane.ERROR_MESSAGE);
						}			
						else
						{
							dateiliste2.getSelectedValue();
							
							JPopupMenu popmen = new JPopupMenu("test");
							
							dateiliste2.add(popmen);
							
							
							
							JMenuItem menu1 = new JMenuItem( "Remove");
							menu1.addActionListener(new ActionListener() {
								public void actionPerformed(ActionEvent arg0)
								{
									deleteSelectedValueInList();
								}
							});
							popmen.add(menu1);
							popmen.show(arg0.getComponent(),arg0.getX(),arg0.getY());	
						}
					}
				
			}
			public void mouseReleased(MouseEvent arg0) {}
			public void mouseEntered(MouseEvent arg0) {}
			public void mouseExited(MouseEvent arg0) {}
		};
		
		dateiliste2.addMouseListener(Maus2);
		
		// these functions are used to make vertical scrolling of left and right window parallel
		scroller2.getVerticalScrollBar().setModel(scroller.getVerticalScrollBar().getModel());
		
		scroller.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		scroller2.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		
		
		 // notwendig, weil sonst kann es passieren, dass beim resizen, die box selbst abstnde macht die nicht
		// hlfte-hlfte sind fr beide scroller
		scroller.setPreferredSize(new Dimension(1,1));
		scroller2.setPreferredSize(new Dimension(1,1));
		
		pfadliste = new JList(); // Geister-Liste, nicht sichtbar, nur zum speichern der pfade der Dateien
		
		info = new JTextArea();
		//info.setBackground(new Color(240,240,240));
		info.setForeground(Color.GRAY);
		info.setEditable(false);
		//info.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY));
		info.setPreferredSize(new Dimension(1,1));
		info.setFont(new Font("Arial",Font.PLAIN,12));
		info.setText("Welcome to TouchMP3 - Version 1.0\n\n" +
		"1. Drag & Drop any files on the white boxes\n" +
		"2. Use LEFT window for editing & preview\n" +
		"3. Press \"Go!\" to write the changes to disk\n\n" +
		"Hints:\n" +
		"Select files to apply changes to SELECTED files only\n" +
		"Clear selection to apply changes to ALL files\n\n" +
		"You can activate MouseOver-Help anytime\nvia menu \"?\" -> \"Help\"");
		
		scrollertemp = new JScrollPane(info);
		scrollertemp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		
		//Create a split pane with the two scroll panes in it.
		//JSplitPane bo = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,scroller2,scroller);
		bo = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,scrollertemp,scroller);		
		bo.setOneTouchExpandable(true);
		bo.setResizeWeight(0.5);
		bo.setDividerSize(5);

		
		
		
		MouseInputListener mil = new dragSelectionListener();
		//dateiliste.addMouseMotionListener(mil);
		//dateiliste.addMouseListener(mil);
		
		// fr "ENTF" Button, tastaturlistener dazufgen
		dateiliste2.addKeyListener(new KeyListener() 
		{
			public void keyTyped(KeyEvent arg0) {}
			public void keyPressed(KeyEvent arg0) {}
			
			public void keyReleased(KeyEvent arg0)
			{
				if(nachgo == 1)
				{
					Toolkit.getDefaultToolkit().beep();
					JOptionPane.showMessageDialog(null,
							"You must either RELOAD the changed files first or CLEAR the filelist\n" +
							"in order to continue working!",
						    "Error",
						    JOptionPane.ERROR_MESSAGE);
				}			
				else
				{
					if(umschalter == 2)
					{
						// entfernen per keytaste soll dekativiert werden beim ID3 modus
					}
					else
					{				
						if(arg0.getKeyCode() == 127)
							deleteSelectedValueInList();
					}
				}
			}
		});
		
		
		dateiliste2.addListSelectionListener(new ListSelectionListener()
		{
			public void valueChanged(ListSelectionEvent arg0)
			{	
				if(arg0.getValueIsAdjusting()==false)
				{
					// hier nix machen momentan
				}
			}
		});
		
		
		pfadliste.addListSelectionListener(new ListSelectionListener()
		{
			public void valueChanged(ListSelectionEvent arg0)
			{				
				//System.out.println(pfadliste.getSelectedIndex());
			}
		});
		
		
		dateiliste2.addMouseMotionListener(mil2);
		dateiliste2.addMouseListener(mil2);
		
			
		tabpane = new JTabbedPane();
		tabpane.setPreferredSize(new Dimension(60,40));
		tabpane.setTabPlacement(JTabbedPane.BOTTOM);
		panel3a = new JPanel();
		panel3a.setLayout(new FlowLayout());
		panel3b = new JPanel();
		
		//Combobox fr button1
		cbx1 = new JComboBox();
		cbx1.setPreferredSize(new Dimension(40,25));
		cbxm1 = new DefaultComboBoxModel(new String[]{"1","2","3","4","5","6","7","8","9"});
		cbx1.setModel(cbxm1);
		
		//Fge alle Buttons zu einem ActionListener hinzu
		button1.addActionListener(new FunctionListener()); // Actlist2
		button111.addActionListener(new FunctionListener());// Actlist2
		button4.addActionListener(new FunctionListener());// Actlist2
		
		

		
		
		
		
		ClassLoader tehloader3 = this.getClass().getClassLoader(); //used for getting icon from .jar file
		java.net.URL addi3 = tehloader3.getResource("pfeil.png"); // icon must be in /src and /bin
		ImageIcon pfeil3 = new ImageIcon(addi3);
		
		JPanel artisto = new JPanel(new BorderLayout());
		artistprev = new JButton(pfeil3);artistprev.setPreferredSize(new Dimension(66,25));
		artistprev.setActionCommand("preview");
		
		artistfield = new JTextField();
		artistfield.setPreferredSize(new Dimension(106,25));
		artistfield.setBackground(new Color(240,231,231));
		artistfield.setBorder(BorderFactory.createLineBorder(new Color(208,177,177),1));
		artistfield.setText("Artistname");
		artistfield.setForeground(new Color(111,67,67));		
		artistfield.setEnabled(true);
		artisto.add(artistfield,BorderLayout.WEST);
		artisto.add(artistprev,BorderLayout.CENTER);
		artistprev.addActionListener(new FunctionListener()); // Actlist2
		// artistfield.addKeyListener(KeyEvent.VK_ENTER); // press [ENTER] to show preview
		
				
		Color bcol2 = new Color(0,0,255);
				
		deltags = new JRadioButton("Delete Tags");
		deltag1 = new JCheckBox("ID3v1");
		deltag2 = new JCheckBox("ID3v2");
		deltag1.setSelected(true);
		deltag2.setSelected(false);
		deltag1.setEnabled(false);
		deltag2.setEnabled(false);
		
		rb111 = new JRadioButton("View Filenames");
		rb222 = new JRadioButton("Filename to Tags");
		tag1 = new JCheckBox("ID3v1");
		tag2 = new JCheckBox("ID3v2");
		tag1.setSelected(false);
		tag2.setSelected(true);
		tag1.setEnabled(false);
		tag2.setEnabled(false);
		rb333 = new JRadioButton("ID3v1");
		rb444 = new JRadioButton("ID3v2");
		rb333.setActionCommand("chid3v1");
		rb444.setActionCommand("chid3v2");
		rb111.setSelected(true);
		bg3 = new ButtonGroup();
		bg3.add(rb111);
		bg3.add(rb222);
		bg3.add(rb333);
		bg3.add(rb444);
		bg3.add(deltags);
		
		//rb222.setForeground(bcol2);
		//rb111.setForeground(bcol2);
		//deltags.setForeground(bcol2);
		
		rb111.addItemListener(mp3Listener);
		rb222.addItemListener(mp3Listener);
		rb333.addItemListener(mp3Listener);
		rb444.addItemListener(mp3Listener);
		tag1.addItemListener(mp3Listener);
		tag2.addItemListener(mp3Listener);
		
		deltags.addItemListener(mp3Listener);
		deltag1.addItemListener(mp3Listener);
		deltag2.addItemListener(mp3Listener);
		
		
		deli1 = new JRadioButton("\" - \"");
		deli2 = new JRadioButton("\"-\"");
		delig = new ButtonGroup();
		
		deli1.setSelected(true);
		delig.add(deli1);
		delig.add(deli2);		
		deli1.addItemListener(deliListener);
		deli2.addItemListener(deliListener);
		
		// dashrenamer
		dashrenamer = new JButton("Redash");
		dashrenamer.addActionListener(new FunctionListener()); // Actlist2
		
		garfield1 = new JButton("ID3v1");	// get Artist/Title from ID3v1
		garfield2 = new JButton("ID3v2");	// get Artist/Title from ID3v2
		garfield1.addActionListener(new FunctionListener2());
		garfield2.addActionListener(new FunctionListener2());
		
		//	erstelle Panels
		JPanel group00 = new JPanel();
		JPanel group0 = new JPanel();
	    JPanel group1 = new JPanel();
		JPanel group2 = new JPanel();
		JPanel group3 = new JPanel();
		JPanel group4 = new JPanel();
				
		
		Font font = new Font("Arial",Font.PLAIN,12);
			
		group00.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue,0),"Use Artist - Title",1,1,font,bcol2));
		group0.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue,0),"Characters",1,1,font,bcol2));
		group1.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue,0),"Options",1,1,font,bcol2));
		group2.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue,0),"Splitpoint",1,1,font,bcol2));
		group3.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue,0),"Delete Characters",1,1,font,bcol2));
		group4.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.blue,0),"Add Artist",1,1,font,bcol2));
		

		Font labelfont = new Font("Arial",Font.PLAIN,12);
		Color labelcolor = new Color(0,0,0);
		
		// 	fge Artist/Title Buttons zum Panel dazu
		group00.setLayout(new GridLayout(2,2,0,2));group00.setPreferredSize(new Dimension(180,74));	
		JLabel labelid1 = new JLabel(" From");labelid1.setForeground(labelcolor);labelid1.setFont(labelfont);
		JLabel labelid2 = new JLabel(" From");labelid2.setForeground(labelcolor);labelid2.setFont(labelfont);
		group00.add(labelid1);group00.add(garfield1);
		group00.add(labelid2);group00.add(garfield2);
		
		//	fge Casestyles zum Panel dazu		
		group0.setLayout(new GridLayout(2,2,0,2));group0.setPreferredSize(new Dimension(180,74));		
		JLabel labellow = new JLabel(" Rename to");labellow.setForeground(labelcolor);labellow.setFont(labelfont);
		JLabel labelupp = new JLabel(" Rename to");labelupp.setForeground(labelcolor);labelupp.setFont(labelfont);		
		group0.add(labellow);group0.add(eins);
		group0.add(labelupp);group0.add(zwo);
		
		//	fge Optionsbuttons zum Panel dazu
		group1.setLayout(new GridLayout(3,2,0,2));group1.setPreferredSize(new Dimension(180,100));
		JLabel labelnum = new JLabel(" Remove");labelnum.setForeground(labelcolor);labelnum.setFont(labelfont);
		JLabel labeltrim = new JLabel(" [Filename]");labeltrim.setForeground(labelcolor);labeltrim.setFont(labelfont);
		JLabel labeldash = new JLabel(" Change all");labeldash.setForeground(labelcolor);labeldash.setFont(labelfont);
		group1.add(labelnum);group1.add(drei);
		group1.add(labeltrim);group1.add(trimmer);
		group1.add(labeldash);group1.add(vier);
		
		
		//	fge Splitpointfunktionen zum Panel dazu
		group2.setLayout(new GridLayout(2,2,0,2));group2.setPreferredSize(new Dimension(180,74));
		group2.add(deli1);
		group2.add(dashrenamer);
		group2.add(deli2);
		group2.add(button4);
		
		//	fge Entfernfunktionen zum Panel dazu		
		group3.setLayout(new BorderLayout());group3.setPreferredSize(new Dimension(180,50));
		group3.add(button1,BorderLayout.WEST);
		group3.add(cbx1,BorderLayout.CENTER);
		group3.add(button111,BorderLayout.EAST);
		
		//	fge Pre-Artistfunktion zum Panel dazu
		group4.setLayout(new GridLayout(1,1,0,0));group3.setPreferredSize(new Dimension(180,50));
		group4.add(artisto);
		
		button1.setPreferredSize(new Dimension(64,30));
		button111.setPreferredSize(new Dimension(66,30));
		
		JPanel group7 = new JPanel();
		
		group7.setLayout(new FlowLayout());group7.setPreferredSize(new Dimension(170,270));
		JPanel group7aaa = new JPanel();
		JPanel group7a = new JPanel();
		JPanel group7b = new JPanel();
		JPanel group7c = new JPanel();
		JPanel group7d = new JPanel();
		JPanel group7e = new JPanel();
		JPanel group7f = new JPanel();
		
		group7aaa.setPreferredSize(new Dimension(173,25));
		group7a.setPreferredSize(new Dimension(174,20));
		group7b.setPreferredSize(new Dimension(130,40));
		group7c.setPreferredSize(new Dimension(174,20));
		group7d.setPreferredSize(new Dimension(130,40));
		group7e.setPreferredSize(new Dimension(173,25));
		group7f.setPreferredSize(new Dimension(135,25));
			
		group7aaa.setLayout(new GridLayout(1,1,0,0)); // "Deactivate"
		group7a.setLayout(new GridLayout(1,1,0,0)); // "deltags"
		group7b.setLayout(new GridLayout(2,1,0,0)); // "deltag1" & "deltag2"
		group7c.setLayout(new GridLayout(1,1,0,0)); // "rb222"
		group7d.setLayout(new GridLayout(2,1,0,0)); // "tag1" & "tag2"
		group7e.setLayout(new GridLayout(1,2,5,0)); // "rb333" & "rb444"
		group7f.setLayout(new BorderLayout(0,0)); // "equalize" 
							
		//group7e.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,1),"View Tags",1,1,font,bcol2));
		button10 = new JButton("Equalize Tags!");
		//button10.setPreferredSize(new Dimension(135,25));
		button10.addActionListener(new Actlist4()); //kommt zu extra actionlistener, weil hie rkonkret ausgefhrt wird
				
		group7aaa.add(rb111);
		group7a.add(deltags);
		group7b.add(deltag1);group7b.add(deltag2);//group7b.add(sepp0);
		group7c.add(rb222);
		group7d.add(tag1);group7d.add(tag2);//group7d.add(sepp);
		//group7e.add(new JLabel(" Check Tags"));
		group7e.add(rb333);
		//group7e.add(new JLabel(" Check Tags"));
		group7e.add(rb444);
		//group7f.add(new JLabel(" Equalize Tags"));
		group7f.add(button10,BorderLayout.CENTER);
				
		Dimension d = new Dimension(170,2);
		//Color sc = Color.LIGHT_GRAY;
		JSeparator sepp = new JSeparator();
		sepp.setPreferredSize(d);//sepp.setBackground(sc);
		
		//maybe change order
		group7.add(group7f);	// Equalize button
		group7.add(group7e);	// Check Tags
		group7.add(group7a);	// Delete Tags
		group7.add(group7b);	// DelTags1,2
		group7.add(group7aaa);	// Deactivated oder "view filenames"
		group7.add(group7c);	// Filename > Tags
		group7.add(group7d);	// Tags1,2
		
		
		
		ClassLoader cls = this.getClass().getClassLoader(); //used fo getting icon from .jar file
		java.net.URL imgurl = cls.getResource("idetag.png"); // icon must be in /src and /bin
		ImageIcon icon = new ImageIcon(imgurl);
		JLabel label = new JLabel(icon);
		JPanel imgpanel = new JPanel();
		imgpanel.setLayout(new BorderLayout());
		imgpanel.add(label,BorderLayout.NORTH);
		imgpanel.setPreferredSize(new Dimension(180,180));
		
		// test for background:
		Color bgc = new Color(196,213,252);
		Color bgch = new Color(161,194,201);
		
		panel3a.setBackground(bgc);
		group00.setBackground(bgc);
		group0.setBackground(bgc);
		group1.setBackground(bgc);
		group2.setBackground(bgc);
		group3.setBackground(bgc);
		group4.setBackground(bgc);
		deli1.setBackground(bgc);
		deli2.setBackground(bgc);
		
		panel3b.setBackground(bgc);
		group7.setBackground(bgc);
		rb222.setBackground(bgc);
		tag1.setBackground(bgc);
		tag2.setBackground(bgc);
		deltags.setBackground(bgc);
		deltag1.setBackground(bgc);
		deltag2.setBackground(bgc);
		imgpanel.setBackground(bgc);
		group7b.setBackground(bgc);
		group7d.setBackground(bgc);
		//hervorhebung der wichtigen funktionen bei ID3
		rb111.setBackground(bgch);
		rb333.setBackground(bgch);
		rb444.setBackground(bgch);
		group7aaa.setBackground(bgch);
		group7e.setBackground(bgch);
		
				
		tabpane.setPreferredSize(new Dimension(180,480));
		panel3a.add(group00);
		panel3a.add(group0);
		panel3a.add(group1);
		panel3a.add(group2);
		panel3a.add(group3);
		panel3a.add(group4);
		tabpane.add("Simple",panel3a);
		
		//panel3b.setPreferredSize(new Dimension(180,500));
		panel3b.setLayout(new BorderLayout());
		panel3b.add(imgpanel,BorderLayout.NORTH);
		panel3b.add(group7,BorderLayout.SOUTH);
		tabpane.add("ID3",panel3b);
		
		tabpane.addChangeListener(new Changelist());
			
		panel3 = new JPanel();
		panel3.setLayout(new FlowLayout());
		
		Font fob = new Font("Arial",Font.BOLD,14); // fr aquabuttons
		Color baqua = new Color(227,227,227);
		
		item2a = new JCheckBox("Auto Reload");
		item2a.addItemListener(optionlistener);

		buttonRELOAD = new AquaButtonPanel(g,"RELOAD");
		buttonRELOAD.setText("RELOAD");
		buttonRELOAD.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(baqua,1)));
		buttonRELOAD.setPreferredSize(new Dimension(85,50));
		buttonRELOAD.setFont(fob);
		buttonRELOAD.addMouseListener(mausi);
		
		JPanel group6 = new JPanel();
		group6.setLayout(new BorderLayout());
		group6.setPreferredSize(new Dimension(180,27));
		//group6.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,1));
		group6.add(item2a,BorderLayout.WEST);		
		
				
		//Erzeuge panel4
		panel4.setLayout(new GridLayout(1,1,0,0));panel4.setPreferredSize(new Dimension(180,90));
		JPanel ipanel = new JPanel(new GridLayout(2,1,0,0));
		
		button99 = new AquaButtonPanel(b,"CLEAR");
		button99.setText("CLEAR");
		
		buttonEXE = new AquaButtonPanel(r,"Go!");//aquaklasse painted den string und die farbe
		buttonEXE.setText("RUN!");				// tatschlich kann jedoch das label vom button anderst sein (hier ist es run)
												// aber draufstehen aufm button soll "go"
		buttonEXE.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(baqua,1)));
		button99.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(baqua,1)));
		button99.setPreferredSize(new Dimension(85,63));
		
		buttonEXE.setPreferredSize(new Dimension(85,63));
		
		buttonEXE.setFont(fob);
		button99.setFont(fob);
		
		button99.addMouseListener(mausi);
		buttonEXE.addMouseListener(mausi);
		
		button99.addActionListener(new Actlist());		
		
		buttonEXE.addActionListener(new Actlist4()); // kommt zu extra actionlistener, weil hier konkret ausgefhrt wird
		buttonRELOAD.addActionListener(new Actlist());
		
		buttonRELOAD.setEnabled(false); // Reloader muss beim ersten Starten deaktiviert sein, bewirkt leider graue schrift bei tooltiptext
		
		ipanel.add(buttonRELOAD);ipanel.add(button99);
		panel4.add(buttonEXE);panel4.add(ipanel);
						
		panel3.setLayout(new BorderLayout());
		
		panel3.add(tabpane,BorderLayout.NORTH);
		
		JPanel ausserhalbvontabpane = new JPanel();
		ausserhalbvontabpane.add(group6);
		ausserhalbvontabpane.add(panel4);
		panel3.add(ausserhalbvontabpane,BorderLayout.CENTER);
		
		logger.info("Umschalter = "+umschalter);//lschen wenns passt
		
		progress = new JProgressBar();
			
		// Overlay a string showing the percentage done
		progress.setStringPainted(true);
		progress.setMinimum(minValue);
		progress.setMaximum(maxValue);
		JPanel proc = new JPanel();
		proc.setLayout(new GridLayout(1,1,0,0));
		proc.add(progress);
		progress.setBorderPainted(true);
		progress.setBackground(new Color(240,240,240));
		
		counterlab = new JLabel("Files loaded: "+listenvektor.size(),SwingConstants.LEFT);
		counterlab.setFont(new Font("Arial",Font.PLAIN,12));
		counterlab.setVerticalAlignment(SwingConstants.CENTER);
		counterlab.setPreferredSize(new Dimension(120,25));
				
		//scroller.setViewportBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,1)));
		//scroller2.setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY,1)));
			    
	    // make layout for bottombar with filecounter & progressbar, fge das nachher  gridbag 1 hinzu
	    JPanel panellll = new JPanel();
		panellll.setLayout(new GridBagLayout());
	    
	    GridBagConstraints c2 = new GridBagConstraints();
		c2.insets = new Insets(0,0,0,0); 
		c2.fill = GridBagConstraints.HORIZONTAL; // soll expandieren nur in der Breite
		
		// soll nur spalten haben, wobei die recht gescaled werden soll
		c2.gridx = 0; 
		c2.gridy = 0;
		c2.gridheight = 1;
		c2.weightx = 0.0; // soll in der breite und
		c2.weighty = 0.0; // in der hhe scalen
		JPanel pannn = new JPanel();
		pannn.add(counterlab);
		//pannn.setBackground(new Color(250,250,250));
		pannn.setPreferredSize(new Dimension(120,30));
		panellll.add(pannn,c2);
	    
		c2.gridx = 1;  // x-Position im gedachten Gitter
		c2.gridy = 0;  // y-Position im gedachten Gitter
		c2.gridheight = 1;  // zwei Gitter-Felder hoch
		c2.weightx = 1.0; // soll nicht in der breite
		c2.weighty = 0.0; // dafr in der hhe scalen
		panellll.add(proc,c2);

		getContentPane().setLayout(new BorderLayout());	// make GridBagLayout
		
		gridbagpanel = new JPanel();
		gridbagpanel.setLayout(new GridBagLayout());
		
		c = new GridBagConstraints();
		// Die Abstnde der einzelnen GUI-Elemente zu den gedachten Gitterlinien festgelegen
		// Reihenfolge: oben-links-unten-rechts
		c.insets = new Insets(0,0,2,5);  
		c.fill = GridBagConstraints.BOTH; // soll expandieren nach allen seiten, wenn man resized
		
		c.gridx = 0;  // x-Position im gedachten Gitter
		c.gridy = 0;  // y-Position im gedachten Gitter
		c.gridheight = 2;  // zwei Gitter-Felder hoch
		c.weightx = 0.0; // soll nicht in der breite
		c.weighty = 1.0; // dafr in der hhe scalen
		panel3.setPreferredSize(new Dimension(180,500)); // for functions
		gridbagpanel.add(panel3,c);
		
		c.gridx = 1; 
		c.gridy = 0;
		c.gridheight = 1;
		c.weightx = 1.0; // soll in der breite und
		c.weighty = 1.0; // in der hhe scalen
		gridbagpanel.add(bo,c);
				
		c.gridx = 1; 
		c.gridy = 1;
		c.weightx = 1.0; // soll in der breite
		c.weighty = 0.0; // aber nicht in der hhe scalen
		c.gridheight = 1;
		gridbagpanel.add(panellll,c);
		
		getContentPane().add(toolbar,BorderLayout.NORTH);
		getContentPane().add(gridbagpanel,BorderLayout.CENTER);
		
		addWindowListener(new CMeinWindowLauscher());
		
		dt = new DropTarget(bo,this);
		dt = new DropTarget(info,this); // muss textarea auch droptarget machen zu beginn
	}
	
	public void undomanager(String[] arrs)
	{
		/* Bei UNDO und REDO wird die Zahl von "pos" verndert, und zwar genau zu jener Zahl, die die Position 
		 * vom UNDO/REDO Zeiger kennzeichnet. Sobald die Zahl unter dem Maximum (max) ist,
		 * werden bei einem erneuten push() alle darberliegenden Stackteile entfernt, damit ein REDO
		 * nicht mehr gltig ist! 
		 */
		if(pos < max)
		{
			for(int i=-max;i<-pos;i++)
			{
				keller.removeElementAt(-i);
				logger.info("pop" + i);
			}
		}
		
		logger.info(arrs);
				
		keller.add(arrs); // TODO hier wird in den Keller reingesteckt
		logger.info("---------------------Eingefgt");
		pos = keller.size()-1;
		max = keller.size()-1;
	}
	
	public void undo()
	{
		if(pos>0)
		{
			pos--;
			String[] undosredos = (String[]) keller.elementAt(pos);
			
			for(int i=0;i<namen.length;i++)
			{
				namen[i] = undosredos[i];
				farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
			}			
		}
		else
		{
			// falls ber dem limit REDO gemacht wird, nichts tun
		}		
	}
	
	public void redo()
	{
		if(pos<max)
		{
			pos++;
			String[] undosredos = (String[]) keller.elementAt(pos);
			
			for(int i=0;i<namen.length;i++)
			{
				namen[i] = undosredos[i];
				farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
			}			
		}
		else
		{
			// falls ber dem limit REDO gemacht wird, nichts tun
		}		
	}
	
	public void clearundomanager()
	{
		keller.clear();
		pos = 0;
		max = 0;
	}
	
	class ActionListenerX implements ActionListener
	{
		public void actionPerformed(ActionEvent akteX)
		{
			String label = akteX.getActionCommand();
			
			if(nachgo == 1)
			{
				Toolkit.getDefaultToolkit().beep();
				JOptionPane.showMessageDialog(null,
						"You must either RELOAD the changed files first or CLEAR the filelist\n" +
						"in order to continue working!",
					    "Error",
					    JOptionPane.ERROR_MESSAGE);
			}			
			else
			{
				if(label.equals("undo"))
				{
					undo();
				}
				if(label.equals("redo"))
				{
					redo();
				}
				if(label.equals("rem"))
				{
					deleteSelectedValueInList();
				}
			}
		}
	}
	
	class KanzlerListener implements ActionListener
	{
		public void actionPerformed(ActionEvent aktekeX)
		{
			String label = aktekeX.getActionCommand();
			
			if(label.equals("STOP"))
			{
				kanzler = 1; // setze prfbit zu 1
				logger.info(kanzler);
				
				if((umschalter == 1)&&(switchnurid == 0))// wenn der renaming vorgang gestoppt wurde!!!
				{
					button99.setEnabled(true);
					buttonRELOAD.setEnabled(true); 
				}
				if((umschalter == 1)&&(switchnurid == 1)) // wenn nur zum rauslesen der tags gestoppt wurde!!!
				{
					button99.setEnabled(true); // soll er nur den clear-button freigeben
				}
			}
		}
	}
		
	MouseListener mausi = new MouseAdapter()
	{	
		// mittels aqua1.u_farbe wird direkt der farbwer verndert
		// repaint() methode bewirkt dass paintComponent() in der AquaButtonKlasse neu ausgefhrt wird
		Object obj;
		/*
		public void mouseEntered(MouseEvent damouse)
		{
			obj = damouse.getSource();
			if(obj==buttonRELOAD)
			{
				buttonRELOAD.u_farbe = hg;
			}
			if(obj==buttonEXE)
			{
				buttonEXE.u_farbe = hr;
			}
			if(obj==button99)
			{
				button99.u_farbe = hb;
			}
			repaint();			
		}*/
		public void mousePressed(MouseEvent damouse)
		{
			obj = damouse.getSource();
			if(obj==buttonRELOAD)
			{
				buttonRELOAD.u_farbe = dg;
				
			}
			if(obj==buttonEXE)
			{
				buttonEXE.u_farbe = dr;
			}
			if(obj==button99)
			{
				button99.u_farbe = db;
			}
			repaint();
		}
		public void mouseReleased(MouseEvent damouse)
		{
			obj = damouse.getSource();
			if(obj==buttonRELOAD)
			{
				buttonRELOAD.u_farbe = g;
				
			}
			if(obj==buttonEXE)
			{
				buttonEXE.u_farbe = r;
			}
			if(obj==button99)
			{
				button99.u_farbe = b;
			}
			repaint();
			
		}
		
		public void mouseExited(MouseEvent damouse)
		{
			obj = damouse.getSource();
			if(obj==buttonRELOAD)
			{
				buttonRELOAD.u_farbe = g;
			}
			if(obj==buttonEXE)
			{
				buttonEXE.u_farbe = r;
			}
			if(obj==button99)
			{
				button99.u_farbe = b;
			}
			repaint();
		}
	};
	
	class Changelist implements ChangeListener
	{
		// This method is called whenever the selected tab changes
		public void stateChanged(ChangeEvent evt)
		{
			JTabbedPane tehpane = (JTabbedPane)evt.getSource();
			
			// Get current tab
	        int index = tehpane.getSelectedIndex();
	        if(index==0) // wenn simple renaming angewhlt ist
	        {
	        	umschalter = 1;
	        	logger.info("Umschalter = "+umschalter);//lschen wenns passt
	        	
	        	// Go button REaktivieren
				buttonEXE.setEnabled(true);	
	        	
	        	// Reset Button aktivieren
	        	buttonRES.setEnabled(true);
	        	undo.setEnabled(true);
	        	redo.setEnabled(true);
	        	rem.setEnabled(true);
	        	
	        	// doppelklick wieder aktivieren
	        	dateiliste2.addMouseListener(Maus2);
	        	
	        	rb111.setSelected(true);
	        	mp3Listener.itemStateChanged(mpe);// bewirkt dass alle anderen RadioButtons deaktiviert werden
	        	
	        }
	        else // wenn ID3 tab angewhlt ist
	        {
	        	umschalter = 2;
	        	logger.info("Umschalter = "+umschalter);//lschen wenns passt
	        	
	        	// Go button DEaktivieren
				buttonEXE.setEnabled(false);	
	        	
	        	// Reset Button deaktivieren
	        	buttonRES.setEnabled(false);
	        	undo.setEnabled(false);
	        	redo.setEnabled(false);
	        	rem.setEnabled(false);
	        	
	        	clearundomanager(); // undo/redo soll nicht mglich sein im ID3 mode 	        	
	        	
	        	// man soll keinen doppelklick machen knnen bei mp3 mode
	        	dateiliste2.removeMouseListener(Maus2);
	        }
	        
	        
	        if(files==null)
	        {	        	
	        }
	        else
	        {	 
	        	for(int i=0;i<files.length;i++) // lade alle alten filenamen wieder
		        {	        	
		        	namen[i] = listenvektor.get(i).toString(); // get "fresh" name first
		        	farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
		        }
	        	if(index==0)
	        	{
	        		dateiliste2.clearSelection(); // es darf nix markiert sein sonst werden nicht alle richtig umbenannt
	        		// beim wechseln der tabs
	        		
		        	resetter(); // damit, falls unterstriche waren im ID3 tab, diese nachher weg sind im "simple" mode
	        		
	        		
		        	// Go button REaktivieren
					buttonEXE.setEnabled(true);	
		        	
		        	
		        	// sobald simple mode angewhlt wird muss er das fr undo redo als ausgangspunkt initialisieren
		        	if(umschalter==1)
					{
						// erstelle array fr den undomanager
						clearundomanager(); //Resette UNDO/REDO zuerst
						String[] endlich = namen.clone();
						System.arraycopy(namen,0,endlich,0,namen.length);
						undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager	
					}		
	        	}
	        }
	    }
	}
	
	ItemListener optionlistener = new ItemListener()
	{
		public void itemStateChanged(ItemEvent help)
		{
			if(item2a.isSelected()==true)
			{
				
			}
			if(item2c.isSelected()==true)
			{
				
			}
		}
	};
	
	
	ItemListener helperlistener = new ItemListener()
	{
		public void itemStateChanged(ItemEvent help)
		{
			if(helper.isSelected()==true)
			{
				ToolTipManager.sharedInstance().setEnabled(true);
				ToolTipManager.sharedInstance().setInitialDelay(300);
	    		ToolTipManager.sharedInstance().setDismissDelay(30000); // jeden tipp 30 sekunden anzeigen
				
				ml = new MouseAdapter()
			    {
			    	public void mouseEntered(MouseEvent e)
			    	{
			    		Object obj = e.getSource();
			    		if(obj == emergency)
			    			emergency.setToolTipText("<HTML><font color='000000'>This option will CANCEL following processes:<br>" +
			    					"- Equalizing Tags<br>" + 
			    					"- Retrieving Taginformation<br>" +
			    					"- Any action, after pressing 'Go!'<br><br>" +
			    					"<u>In order to continue working after a cancelling process you MUST follow these rules:</u><br>" +
			    					"In 'Simple' mode press RELOAD (or CLEAR the filelist)<br>" +
			    					"In 'ID3' mode, simply switch to another radiobutton and back");
			    		if(obj == rem)
			    			rem.setToolTipText("<HTML>Remove selected files from list.");
			    		if(obj == undo)
			    			undo.setToolTipText("<HTML><font color='000000'>Undo");
			    		if(obj == redo)
			    			redo.setToolTipText("<HTML><font color='000000'>Redo");
			    		if(obj == item2a)
			    			item2a.setToolTipText("<HTML>Immediately reloads all changed files after pressing \"Go!\"<br>" +
			    					"You may want to deactivate this option, in case you want to inspect certain files,<br>" +
			    					"which were marked with a different background color (e.g. double files)<br>");
			    		if(obj == deltags)
			    			deltags.setToolTipText("<HTML>This function will COMPLETELY remove the ID3 version being selected,<br>" +
			    					"including all contents in it. You may want to remove the older version ID3v1.");
			    		if(obj == garfield1)
			    			garfield1.setToolTipText("<HTML>Tries to read ARTIST and TITLE from MP3-Tag ID3v1 and use it<br>" +
			    					"on the filename according to the pattern [Artist] - [Title].<br>" +
			    					"If ID3v1 does not exist or any of the Artist/Title fields is empty, the filename<br>" +
			    					"will NOT be changed!<br><br>" +
			    					"Beware also, that ID3v1 can only contain a limited number of characters and<br>" +
			    					"your new filename may end up incomplete!");
			    		if(obj == garfield2)
			    			garfield2.setToolTipText("<HTML>Tries to read ARTIST and TITLE from MP3-Tag ID3v2 and use it<br>" +
			    					"on the filename according to the pattern [Artist] - [Title].<br>" +
			    					"If ID3v2 does not exist or any of the Artist/Title fields is empty, the filename<br>" +
			    					"will NOT be changed!");
			    		if(obj == dashrenamer)
			    			dashrenamer.setToolTipText("<HTML>Depending on the SPLITPOINT being selected this function splits<br>" +
			    					"the filename into a number of parts separated by each dash being found and connects these parts again according to <br>" +
			    					"the pattern [Artist] - [Title]. The main target is to achieve a filename with only ONE dash surrounded by whitespaces!<br><br>" +
			    					"e.g.: Use of: \" - \": John Rhyse -Dapper - La -Borg &#8680; John Rhyse-Dapper - La-Borg<br>" +
			    					"e.g.: Use of: \"-\": John Rhyse -Dapper - La -Borg &#8680; John Rhyse - Dapper-La-Borg");
			    		if(obj == item2c)
			    			item2c.setToolTipText("<HTML>This function will create a new filelist each time you drop any files.");
			    		if(obj == item3a)
			    			item3a.setToolTipText("<HTML>Replaces all underscores with a single whitespace, including extraordinary cases.<br><br>" +
			    					"e.g.: ____Artist____-_Title___.___mp3_ &#8680; Artist - Title.mp3");
			    		if(obj == item3b)
			    			item3b.setToolTipText("<HTML>Replaces all whitespaces with a single whitespace, including extraordinary cases.<br><br>" +
			    					"e.g.:     Artist    -  Title    .  mp3 &#8680; Artist - Title.mp3");
			    		if(obj == item3c)
			    			item3c.setToolTipText("<HTML>Replaces all accent characters falsely used as quotes with quotes.<br><br>" +
			    					"e.g.: Rock n` Roll.mp3 &#8680; Rock 'n' Roll.mp3");
			    		if(obj == eins)
			    			eins.setToolTipText("<HTML>Renames all characters of filename to LOWER case (including extension).<br><br>" +
			    					"e.g.: Artist - Title.mp3 &#8680; artist - title.mp3");
			    		if(obj == zwo)
			    			zwo.setToolTipText("<HTML>Renames all characters of filename to UPPER case (including extension).<br><br>" +
			    					"e.g.: Artist - Title.mp3 &#8680; ARTIST - TITLE.MP3");
			    		if(obj == drei)
			    			drei.setToolTipText("<HTML>Removes all numbers/characters at the beginning of a filename until it reaches an alphabetic letter.<br><br>" +
			    					"e.g.: (01)-_Artist - Title.mp3 &#8680; Artist - Title.mp3");
			    		if(obj == trimmer)
			    			trimmer.setToolTipText("<HTML>Removes whitespaces at the beginning and end of a filename.<br><br>" +
			    					"e.g.: [ Artist - Title.mp3 ] &#8680; [Artist - Title.mp3]");
			    		if(obj == vier)
			    			vier.setToolTipText("<HTML>Adds a whitespace on the left and right side of each dash.<br><br>" +
			    					"e.g.: Artist-Title.mp3 &#8680; Artist - Title.mp3<br><br>" +
			    					"Hint: Use in combination with 'Redash' to create a pattern like 'Artist - Title'.");
			    		if(obj == rb2)
			    			rb2.setToolTipText("<HTML>This function will FLAG all filenames that are double/triple/+ at the beginning with underscores.<br>" +
			    					"The amount of underscores depends on the number of files with the same filename.<br><br>" +
			    					"e.g.: you want to rename 2 files to 'seabound - hooked.mp3':<br>" + 
			    					"51-Seabound - Hooked.mp3 &#8680; will be renamed to: seabound - hooked.mp3<br>" +
			    					"05-Seabound_-_Hooked.mp3 &#8680; will be renamed to: _seabound - hooked.mp3");
			    		if(obj == rb1)
			    			rb1.setToolTipText("<HTML>This function will SKIP the renaming action on each file that is double/triple/+.<br><br>" +
			    					"e.g.: you want to rename 2 files to 'seabound - hooked.mp3':<br>" + 
			    					"51-Seabound - Hooked.mp3 &#8680; will be renamed to: seabound - hooked.mp3<br>" +
			    					"05-Seabound_-_Hooked.mp3 &#8680; will remain: 05-Seabound_-_Hooked.mp3");
			    		if(obj == button1)
			    			button1.setToolTipText("<HTML>Deletes an amount of characters from the LEFT side of the filename.<br><br>" +
			    					"e.g.: Cd1_Artist - Title.mp3 &#8680; Artist - Title.mp3");
			    		if(obj == button111)
			    			button111.setToolTipText("<HTML>Deletes an amount of characters from the RIGHT side of the filename<br>" +
			    					"starting from the 4th position of its end (extension).<br><br>" +
									"e.g.: Artist - Title_by_3vilH4x0r.mp3 &#8680; Artist - Title.mp3");
			    		if(obj == cbx1)
			    			cbx1.setToolTipText("<HTML>Determines amount of charactes deleted from the left or right side.");
			    		if(obj == deli1)
			    			deli1.setToolTipText("<HTML>Dash with whitespaces as SPLITPOINT between ARTIST and TITLE. Always uses the FIRST \" - \" being found!<br>" +
			    					"Important when using 'Swap Name' or 'Filename > Tags'.<br><br>" +
			    					"e.g.: Akon feat. Ray-Jay - The Reckoning.mp3<br>" +
			    					"&#8680; Artist will be: Akon feat. Ray-Jay<br>" +
			    					"&#8680; Title will be: The Reckoning'");
			    		if(obj == deli2)
			    			deli2.setToolTipText("<HTML>Pure dash as SPLITPOINT between ARTIST and TITLE. Always uses the FIRST \"-\" being found!<br>" +
			    					"Important when using 'Swap Name' or 'Filename > Tags'.<br><br>" +
			    					"BEWARE: Akon feat. Ray-Jay - The Reckoning<br>" +
			    					"&#8680; Artist will be: Akon feat. Ray<br>" +
			    					"&#8680; Title will be: Jay-The Reckoning<br><br>" +
			    					"Hint: for safe use, make sure there is only one dash within a filename");
			    		if(obj == button4)
			    			button4.setToolTipText("<HTML>Swaps ARTIST and TITLE determined by SPLITPOINT.<br><br>" +
			    					"e.g.: Ooops - Britney Spears.mp3 &#8680; Britney Spears - Ooops.mp3");
			    		if(obj == artistfield)
			    			artistfield.setToolTipText("<HTML>Adds typed TEXT to the beginning of each filename and adds a \" - \" behind it.<br><br>" +
			    					"e.g.: Bounce.mp3 &#8680; Bon Jovi - Bounce.mp3<br><br>" +
			    					"Hint: use when you have lots of files by the same artist but filenames only includes title.");
			    		if(obj == artistprev)
			    			artistprev.setToolTipText("<HTML>Shows preview of new filename.");
			    		
			    		if(obj == clearsel)
			    			clearsel.setToolTipText("<HTML>This Button clears the selections in the filelist.<br><br>" +
			    					"Actions taken on the list, where files are selected, will be applied to the selected files ONLY!<br>" +
			    					"Actions taken on the list, where NO files are selected, will be applied to ALL files!");
			    		if(obj == rb111)
			    			rb111.setToolTipText("<HTML>View filenames in their original state (without underscores etc. being removed).");
			    		if(obj == rb222)
			    			rb222.setToolTipText("<HTML>This function tries to create an ARTIST and TITLE tag out of the filename and tags ID3v1/v2.<br>" +
			    					"It heavily depends on the SPLITPOINT being set; you MUST(!) style the filename before using this option,<br>" +
			    					"or else you will receive wrong results. A correct style can be achieved with the option \"Redash\".<br>" +
			    					"- Existing Artist/Title tags will be overwritten; no other tags, however, will be changed. <br>" +
			    					"- Beware that ID3v1 can only contain a limited number of characters. Therefore it is recommended to use ID3v2 only!<br><br>" +
			    					"e.g.: filename is 'Evils Toy - Angels Only.mp3'<br>" +
			    					"&#8680; Artist-Tag will be: Evils Toy<br>" +
			    					"&#8680; Title-Tag will be: Angels Only");
			    		if(obj == rb333)
			    			rb333.setToolTipText("<HTML>This function tries to read ARTIST and TITLE from ID3v1.<br><br>" +
			    					"Artist-Tag is: Waterboys<br>" +
			    					"Title-Tag is: Whole of the Moon<br>" +
			    					"&#8680; Output will be: [Waterboys] - [Whole of the Moon]");
			    		if(obj == rb444)
			    			rb444.setToolTipText("<HTML>This function tries to read ARTIST and TITLE from ID3v2.<br><br>" +
			    					"Artist-Tag is: Waterboys<br>" +
			    					"Title-Tag is: Whole of the Moon<br>" +
			    					"&#8680; Output will be: [Waterboys] - [Whole of the Moon]");
			    		if(obj == button10)
			    			button10.setToolTipText("<HTML>This function compares ARTIST and TITLE from both ID3v1 and ID3v2 and tries to equalize them.<br>" +
			    					"If both Tag-fields in both ID3v1 and ID3v2 are incomplete by means that either<br>" +
			    					"ARTIST or TITLE is missing or empty in both, no Tag-changes will be performed!<br>" +
			    					"Function will always try to use ID3v2 tags as the first base.<br><br>" +
			    					"<font color='ff0000'>BEWARE that this is the only function that will not show a preview but perform the action instantly!</font>");
			    		if(obj == button99)
			    			button99.setToolTipText("<HTML>CLEAR cache and filelist.<br>" +
			    					"You MUST use 'RELOAD' or 'CLEAR' in order to continue working after a 'Go!'.");
			    		if(obj == buttonRES)
			    			buttonRES.setToolTipText("<HTML><font color='000000'>Reset ALL filenames or<br>" +
			    					"Reset SELECTED filenames only!");
			    		if(obj == buttonEXE)
			    			buttonEXE.setToolTipText("<HTML><font color='000000'>This button - in the end - writes all changes to the filename or tags!<br>" +
			    					"Unless this button is pressed, the preview window will safely show the result of your actions<br>" +
			    					"taken on the files without the original files being changed!");
			    		if(obj == buttonRELOAD)
			    			buttonRELOAD.setToolTipText("<HTML><font color='000000'>RELOAD all changed files.<br>" +
			    					"You MUST use 'RELOAD' or 'CLEAR' in order to continue working after a 'Go!'."); //schwarz machen, weil sonst grau ist, wegen "disabled"
			    	}
			        public void mouseExited(MouseEvent e) 
			        {
			        	
			        } 
			    };
			    
			    emergency.addMouseListener(ml);
			    rem.addMouseListener(ml);
			    undo.addMouseListener(ml);
			    redo.addMouseListener(ml);
			    item2a.addMouseListener(ml);
			    deltags.addMouseListener(ml);
			    garfield1.addMouseListener(ml);
			    garfield2.addMouseListener(ml);
			    dashrenamer.addMouseListener(ml);
			    item2c.addMouseListener(ml);
			    rb1.addMouseListener(ml);
			    rb2.addMouseListener(ml);
			    eins.addMouseListener(ml);
			    zwo.addMouseListener(ml);
			    drei.addMouseListener(ml);
			    vier.addMouseListener(ml);
			    trimmer.addMouseListener(ml);
			    item3a.addMouseListener(ml);
			    item3b.addMouseListener(ml);
			    item3c.addMouseListener(ml);			    
			    button1.addMouseListener(ml);
			    button111.addMouseListener(ml);
			    cbx1.addMouseListener(ml);
			    deli1.addMouseListener(ml);
			    deli2.addMouseListener(ml);
			    button4.addMouseListener(ml);
			    artistfield.addMouseListener(ml);
			    artistprev.addMouseListener(ml);
			    clearsel.addMouseListener(ml);
			    rb111.addMouseListener(ml);
			    rb222.addMouseListener(ml);
			    rb333.addMouseListener(ml);
			    rb444.addMouseListener(ml);
			    button10.addMouseListener(ml);
			    button99.addMouseListener(ml);
			    buttonRES.addMouseListener(ml);
			    buttonEXE.addMouseListener(ml);
			    buttonRELOAD.addMouseListener(ml);
			    
			}
			else // ToolTips deaktivieren
			{
				ToolTipManager.sharedInstance().setEnabled(false);
			}
		}
	};
	
	
	
	ItemListener listener123 = new ItemListener() // TODO fr markierte noch
	{
		public void itemStateChanged(ItemEvent einszwodrei)
		{			
			if(files==null)
			{
			}
			else
			{
				Object[] selected22 = dateiliste2.getSelectedValues();
				int anzahlmarkierte22 = dateiliste2.getSelectedValues().length;
				
				if(anzahlmarkierte22==0) // falls keine datei markiert ist, soll er ALLE umbenennen
				{
					//	soll er ALLE umbenennen, _immer_
					for(int i=0;i<listenvektor.size();i++)
					{
						if(item3a.isSelected()==true)
						{
							namen[i] = underscores(namen[i]);
						}				
						if(item3b.isSelected()==true)
						{
							namen[i] = whitespaces(namen[i]);
						}
						if(item3c.isSelected()==true)
						{
							namen[i] = quotes(namen[i]);
						}
						namen[i] = trimit(namen[i]); // trimme die files noch alle
						farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
					}		
				}
				else
				{
					for(int i=0;i<selected22.length;i++)
					{
						int pos22 = (int) farbmodel.indexOf(selected22[i]); // bestimme zuerst die position wo gelscht werden soll (fr geisterliste)
						
						if(item3a.isSelected()==true)
						{
							namen[pos22] = underscores(namen[pos22]);
						}				
						if(item3b.isSelected()==true)
						{
							namen[pos22] = whitespaces(namen[pos22]);
						}
						if(item3c.isSelected()==true)
						{
							namen[pos22] = quotes(namen[pos22]);
						}
						namen[pos22] = trimit(namen[pos22]); // trimme die files noch alle
						farbmodel.setElementAt(new ListItem(col1,namen[pos22]),pos22);
					}
					String[] endlich = namen.clone();
					System.arraycopy(namen,0,endlich,0,namen.length);
					undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
				}
			}
		}
	};
	
	class FunctionListener2 implements ActionListener
	{
		public void actionPerformed(ActionEvent gex)
		{
			label = gex.getActionCommand();
			
			if(files==null)
			{
			}
			else
			{
				if(nachgo == 1)
				{
					Toolkit.getDefaultToolkit().beep();
					JOptionPane.showMessageDialog(null,
							"You must either RELOAD the changed files first or CLEAR the filelist\n" +
							"in order to continue working!",
						    "Error",
						    JOptionPane.ERROR_MESSAGE);
				}			
				else // TODO hie rmuss noch was gemacht werden, weil er bei einen der funktionen einfriert!!!
				{
							
					Object[] selected2 = dateiliste2.getSelectedValues();
					int anzahlmarkierte = dateiliste2.getSelectedValues().length;
					
					namemp3 = new String[files.length]; // initialisiere gre des namemp3 string array				
					
					
					
					if(anzahlmarkierte==0) // falls keine datei markiert ist, soll er ALLE umbenennen
					{
							if(label.equals("ID3v1"))
							{
								
								int maxValue2 = files.length;	// bestimme maximalwert fr progressbar
								threadit2 = maxValue2; 			// bestimme maximalwert fr threadschleife
								
								// indeterminate progressbar machen 
								progress.setIndeterminate(true);
								progress.setString("Retrieving Tag-Information...");
								
								emergency.setEnabled(true); //emergency button aktivieren
								
								disableRBs();
								disablebutts();
								
								switchnurid = 1;// 1 gesetzt als zeichen, dass nur das tagauslesen gestartet wurde
								
								Thread runner2 = new Thread()
								{
									public void run()
									{
										for(int q=0;q<threadit2;q++)
										{
												try
												{
													// probiere funktion und msste eine form von artist+" - "+title zurckbekommen! 
													namemp3[q] = tag1tofilename(files[q]); // hier bekomme ich "artist - title" ohne endung
													
													// splitte den namen von namemp3[i]
													// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
													Scanner scanner = new Scanner(namemp3[q]).useDelimiter(" - ");
													String artist = scanner.next();
													String title = scanner.next();
													
													//Der Scanner muss drin bleiben, weil der prft, ob der String ohne ERROR zurckgeliefert wurde;
													// lsst der String sich nicht splitten => ERROR String => Exception wird aufgerufen
																				
													namemp3[q] = namemp3[q]+".mp3"; // fge erst hier die endung hinzu
													namen[q] = namemp3[q];
												}
												catch(Exception awdadawd) 
												// wenn splitten nicht geht bzw. der ERROR String geliefert wurde, soll er einfach NIX tun! :-) 
												{
												}
												// zum debuggen: zeigt liste an, vor dem listener123
												//farbmodel.setElementAt(new ListItem(col1,namen[q]),q);
												
												// abschliessend muss der einszwodreilistener ausgefhrt werden damit gleich unterstriche usw. weg sind
												// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
												listener123.itemStateChanged(einszwodrei);
												
												progress.setString("Retrieving Tag-Information..."+q);
												
												if(kanzler == 1)
							            		{
							            			break;	// wenn "stop" gedrckt wird soll die schleife abgebrochen werden
							            		}  
										}
										
										String[] endlich = namen.clone();
										System.arraycopy(namen,0,endlich,0,namen.length);
										undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
																
										// nach dem "break"; bzw. nachdem die schleife fertig ist, soll er sofort wieder den kanzler 0 setzen
										emergency.setEnabled(false);
						            	kanzler = 0;
						            	logger.info("Letzter Wert von Kanzler = " +kanzler);
										
										progress.setString(null);
										progress.setIndeterminate(false);
										
										enableRBs();
										enablebutts();
										
									}
								};
								runner2.start();
							}
							
							if(label.equals("ID3v2"))
							{
								int maxValue2 = files.length;	// bestimme maximalwert fr progressbar
								threadit2 = maxValue2; 			// bestimme maximalwert fr threadschleife
								
								// indeterminate progressbar machen 
								progress.setIndeterminate(true);
								progress.setString("Retrieving Tag-Information...");
								
								emergency.setEnabled(true); //emergency button aktivieren
								
								disableRBs();
								disablebutts();
								
								switchnurid = 1; // 1 gesetzt als zeichen, dass nur das tagauslesen gestartet wurde
								
								Thread runner2 = new Thread()
								{
									public void run()
									{
										for(int q=0;q<threadit2;q++)
										{
								
												try
												{
													// probiere funktion und msste eine form von artist+" - "+title zurckbekommen! 
													namemp3[q] = tag2tofilename(files[q]); // hier bekomme ich "artist - title" ohne endung
													
													// splitte den namen von namemp3[i]
													// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
													Scanner scanner = new Scanner(namemp3[q]).useDelimiter(" - ");
													String artist = scanner.next();
													String title = scanner.next();
													
													//Der Scanner muss drin bleiben, weil der prft, ob der String ohne ERROR zurckgeliefert wurde;
													// lsst der String sich nicht splitten => ERROR String => Exception wird aufgerufen
																				
													namemp3[q] = namemp3[q]+".mp3"; // fge erst hier die endung hinzu
													namen[q] = namemp3[q];
												}
												catch(Exception awdadawd) 
												// wenn splitten nicht geht bzw. der ERROR String geliefert wurde, soll er einfach NIX tun! :-) 
												{
												}
												// zum debuggen: zeigt liste an, vor dem listener123
												//farbmodel.setElementAt(new ListItem(col1,namen[q]),q);
												
												// abschliessend muss der einszwodreilistener ausgefhrt werden damit gleich unterstriche usw. weg sind
												// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
												listener123.itemStateChanged(einszwodrei);
												
												progress.setString("Retrieving Tag-Information..."+q);
												
												if(kanzler == 1)
							            		{
							            			break;	// wenn "stop" gedrckt wird soll die schleife abgebrochen werden
							            		}  
										}
										
										String[] endlich = namen.clone();
										System.arraycopy(namen,0,endlich,0,namen.length);
										undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
										
										// nach dem "break"; bzw. nachdem die schleife fertig ist, soll er sofort wieder den kanzler 0 setzen
										emergency.setEnabled(false);
						            	kanzler = 0;
						            	logger.info("Letzter Wert von Kanzler = " +kanzler);
										
										progress.setString(null);
										progress.setIndeterminate(false);
										
										enableRBs();
										enablebutts();
												
									}
								};
								runner2.start();
						}
					}
					
					
					//TODO jumppunkt
					// hier spar ich mir die 
					//1. "retrieving tag-information" weil die markierten meist nur wenige sind (~50 stck)
					// vermutlich grad mal soviel wie auf der seite angezeigt werden knnen
					// diese tags liest das programm innerhalb einer sekunde aus
					//2. das blockieren von tabpane 2 und der die stop funktion
					// weil es sowieso schnell geht
					
					else // sonst nur die markierten
					{
						for(int i=0;i<selected2.length;i++)
						{
							pos3 = (int) farbmodel.indexOf(selected2[i]); // bestimme zuerst die position wo gelscht werden soll (fr geisterliste)
							
							if(label.equals("ID3v1"))
							{
								
												try
												{
													// probiere funktion und msste eine form von artist+" - "+title zurckbekommen! 
													namemp3[pos3] = tag1tofilename(files[pos3]); // hier bekomme ich "artist - title" ohne endung
													
													// splitte den namen von namemp3[i]
													// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
													Scanner scanner = new Scanner(namemp3[pos3]).useDelimiter(" - ");
													String artist = scanner.next();
													String title = scanner.next();
													
													//Der Scanner muss drin bleiben, weil der prft, ob der String ohne ERROR zurckgeliefert wurde;
													// lsst der String sich nicht splitten => ERROR String => Exception wird aufgerufen
																				
													namemp3[pos3] = namemp3[pos3]+".mp3"; // fge erst hier die endung hinzu
													namen[pos3] = namemp3[pos3];
													
													// abschliessend muss der einszwodreilistener ausgefhrt werden damit gleich unterstriche usw. weg sind
													// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
													farbmodel.setElementAt(new ListItem(col1,namen[pos3]),pos3);
												}
												catch(Exception awdadawd) 
												// wenn splitten nicht geht (weil der ERROR string zurckgeliefert wurde, soll er einfach NIX tun! :-)  
												{
													// der markierte name bleibt so wie er ist
												}			
												
												
							}
							if(label.equals("ID3v2"))
							{
												try
												{
													// probiere funktion und msste eine form von artist+" - "+title zurckbekommen! 
													namemp3[pos3] = tag2tofilename(files[pos3]); // hier bekomme ich "artist - title" ohne endung
													
													// splitte den namen von namemp3[i]
													// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
													Scanner scanner = new Scanner(namemp3[pos3]).useDelimiter(" - ");
													String artist = scanner.next();
													String title = scanner.next();
													
													//Der Scanner muss drin bleiben, weil der prft, ob der String ohne ERROR zurckgeliefert wurde;
													// lsst der String sich nicht splitten => ERROR String => Exception wird aufgerufen
																				
													namemp3[pos3] = namemp3[pos3]+".mp3"; // fge erst hier die endung hinzu
													namen[pos3] = namemp3[pos3];
													
													// abschliessend muss der einszwodreilistener ausgefhrt werden damit gleich unterstriche usw. weg sind
													// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
													farbmodel.setElementAt(new ListItem(col1,namen[pos3]),pos3);
												}
												catch(Exception awdadawd) 
												// wenn splitten nicht geht (weil der ERROR string zurckgeliefert wurde, soll er einfach NIX tun! :-)
												{
													// der markierte name bleibt so wie er ist
												}			
												
												
							}
							
						}
						listener123.itemStateChanged(einszwodrei); // im endeffekt zeigt er das ergebnis erst ab hier an
						String[] endlich = namen.clone();
						System.arraycopy(namen,0,endlich,0,namen.length);
						undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
					}
					
				}
			}
		}
	}
	
	class FunctionListener implements ActionListener
	{
		public void actionPerformed(ActionEvent fev)
		{
			label = fev.getActionCommand();
			
			if(files==null)
			{
			}
			else
			{
				if(nachgo == 1)
				{
					Toolkit.getDefaultToolkit().beep();
					JOptionPane.showMessageDialog(null,
							"You must either RELOAD the changed files first or CLEAR the filelist\n" +
							"in order to continue working!",
						    "Error",
						    JOptionPane.ERROR_MESSAGE);
				}				
				else
				{
					Object[] selected2 = dateiliste2.getSelectedValues();
					int anzahlmarkierte = dateiliste2.getSelectedValues().length;
					
					if(anzahlmarkierte==0) // falls keine datei markiert ist, soll er ALLE umbenennen
					{
						for(int i=0;i<listenvektor.size();i++)
						{
							if(label.equals("lowerC"))
							{
								namen[i] = lowerCase(namen[i]);
							}
							if(label.equals("upperC"))
							{
								namen[i] = upperCase(namen[i]);
							}
							if(label.equals("Number"))
							{
								namen[i] = numbers(namen[i]);
							}
							if(label.equals("Trimmer"))
							{
								namen[i] = trimit(namen[i]);
							}						
							if(label.equals("\"-\" to \" - \""))
							{
								namen[i] = dashes(namen[i]);
							}
							if(label.equals("R"))
							{
								namen[i] = delright(namen[i]);
							}
							if(label.equals("L"))
							{
								namen[i] = delleft(namen[i]);
							}
							if(label.equals("Redash"))
							{
								namen[i] = redash(namen[i]);
							}
							if(label.equals("Swap"))
							{
								namen[i] = swap(namen[i]);
							}
							if(label.equals("preview"))
							{
								namen[i] = setartist(namen[i]);
							}
							farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
						}
						String[] endlich = namen.clone();
						System.arraycopy(namen,0,endlich,0,namen.length);
						undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager 
						// diese zeilen sind alle notwendig, weil er sonst im undomanager immer denselben (falschen) array einfgt
					}
					else // sonst nur die markierten
					{
						for(int i=0;i<selected2.length;i++)
						{
							int pos2 = (int) farbmodel.indexOf(selected2[i]); // bestimme zuerst die position wo gelscht werden soll (fr geisterliste)
							
							if(label.equals("lowerC"))
							{
								namen[pos2] = lowerCase(namen[pos2]);
							}
							if(label.equals("upperC"))
							{
								namen[pos2] = upperCase(namen[pos2]);
							}
							if(label.equals("Number"))
							{
								namen[pos2] = numbers(namen[pos2]);
							}
							if(label.equals("Trimmer"))
							{
								namen[pos2] = trimit(namen[pos2]);
							}		
							if(label.equals("\"-\" to \" - \""))
							{
								namen[pos2] = dashes(namen[pos2]);
							}
							if(label.equals("R"))
							{
								namen[pos2] = delright(namen[pos2]);
							}
							if(label.equals("L"))
							{
								namen[pos2] = delleft(namen[pos2]);
							}
							if(label.equals("Redash"))
							{
								namen[pos2] = redash(namen[pos2]);
							}
							if(label.equals("Swap"))
							{
								namen[pos2] = swap(namen[pos2]);
							}
							if(label.equals("preview"))
							{
								namen[pos2] = setartist(namen[pos2]);
							}
							farbmodel.setElementAt(new ListItem(col1,namen[pos2]),pos2);
						}
						String[] endlich = namen.clone();
						System.arraycopy(namen,0,endlich,0,namen.length);
						undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
					}
				}
			}
		}
	}
    
    ItemListener deliListener = new ItemListener()
    {
    	public void itemStateChanged(ItemEvent dL)
    	{
	    	if(deli1.isSelected()==true)
			{
				//output("Delimiter 1 chosen!\n",def);
			}
	    	else if(deli2.isSelected()==true)
			{
				//output("Delimiter 2 chosen!\n",def);
			}
    	}
    };
    
    
    public void enableRBs()
    {
    	if(umschalter == 1)
    	{
    		tabpane.setEnabledAt(1,true);
    	}
    	else
    	{
    		tabpane.setEnabledAt(0,true);
    	}
    	//re-aktiviere alle radiobuttons
    	button10.setEnabled(true);
    	deltags.setEnabled(true);
		rb444.setEnabled(true);
		rb333.setEnabled(true);
		rb222.setEnabled(true);
		rb111.setEnabled(true);
		if(deltags.isSelected()==true)
		{
			deltag1.setEnabled(true);
			deltag2.setEnabled(true);
		}
		if(rb222.isSelected()==true)
		{
			tag1.setEnabled(true);
			tag2.setEnabled(true);
		}
    }
    public void disableRBs()
    {
    	if(umschalter == 1)
    	{
    		tabpane.setEnabledAt(1,false);
    	}
    	else
    	{
    		tabpane.setEnabledAt(0,false);
    	}   	
    	
    	//de-aktiviere alle radiobuttons
    	button10.setEnabled(false);
    	deltags.setEnabled(false);
		rb444.setEnabled(false);
		rb333.setEnabled(false);
		rb222.setEnabled(false);
		rb111.setEnabled(false);
		if(deltags.isSelected()==true)
		{
			deltag1.setEnabled(false);
			deltag2.setEnabled(false);
		}
		if(rb222.isSelected()==true)
		{
			tag1.setEnabled(false);
			tag2.setEnabled(false);
		}
		
    }
    
    
    ItemListener mp3Listener = new ItemListener()
	{
		public void itemStateChanged(ItemEvent mpe)
		{
			if(files==null)
			{
			}
			else
			{
				
				
				namemp3 = new String[files.length]; // initialisiere gre des namemp3 string array
				namemp3temp = new String[files.length]; // initialisiere temp array der nur fr darstellung zustndig ist
				
				if(rb111.isSelected()==true)	// View Filenames RadioButton
				{
					
					// bei jedem wechsel von radiobutton zu radiobutton soll er die progressbar resetten
					progress.setValue(0);
					
					// nur auf der ID3 seite das machen!
					if(umschalter==2)
					{
						// Go button deaktivieren
						buttonEXE.setEnabled(false);
					}
					
					tag1.setEnabled(false);
					tag2.setEnabled(false);
					deltag1.setEnabled(false);
					deltag2.setEnabled(false);
					
					
					for(int i=0;i<files.length;i++)
					{
						// zuerst hole originalnamen in die liste
						//namen[i] = listenvektor.get(i).toString();
						
						farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
					}		
					
				}
				else if(deltags.isSelected()==true)	// Delete Tags RadioButton
				{
					// bei jedem wechsel von radiobutton zu radiobutton soll er die progressbar resetten
					progress.setValue(0);
					
					// Go button REaktivieren
					buttonEXE.setEnabled(true);	
					
					tag1.setEnabled(false);
					tag2.setEnabled(false);
					deltag1.setEnabled(true);
					deltag2.setEnabled(true);
					
					for(int i=0;i<files.length;i++)
					{
						String ing = "Will try to delete Tags here!";
						farbmodel.setElementAt(new ListItem(col1,ing),i);
					}				
				}
				else if(rb222.isSelected()==true)	// Filename to Tags RadioButton
				{
					// bei jedem wechsel von radiobutton zu radiobutton soll er die progressbar resetten
					progress.setValue(0);
					
					// Go button REaktivieren
					buttonEXE.setEnabled(true);	

					tag1.setEnabled(true);
					tag2.setEnabled(true);
					deltag1.setEnabled(false);
					deltag2.setEnabled(false);
					
					for(int i=0;i<files.length;i++)
					{
						namen[i] = listenvektor.get(i).toString(); // get "fresh" name first
						namemp3[i] = filenametotag(namen[i]);
						
						try
						{
							// dies funktion macht splittet die beiden teile von namemp3[i]
							// und gibt eine leicht vernderte ausgabe an die liste zurck
							// ist fr den user damit er den unterschied besser sehen kann
							// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
							Scanner scanner = new Scanner(namemp3[i]).useDelimiter(" - ");
							String artist = scanner.next();
							String title = scanner.next();
							namemp3temp[i] = "[" + artist + "]   -   [" + title + "]"; 
							
							// wenns klappt, in liste ausgeben
							farbmodel.setElementAt(new ListItem(col1,namemp3temp[i]),i);
						}
						catch(Exception awdadawd) // wenn splitten nicht geht, soll er die meldung der methode ausgeben
						{
							namemp3temp[i] = namemp3[i];
							
							//  wo es nicht ging , farblich rot unterlegen
							farbmodel.setElementAt(new ListItem(col4,namemp3temp[i]),i);
						}						
					}				
				}
				else if(rb333.isSelected()==true) // Show Tag ID3v1 RadioButton
				{
					// bei jedem wechsel von radiobutton zu radiobutton soll er die progressbar resetten
					progress.setValue(0);
					
					// nur auf der ID3 seite das machen!
					if(umschalter==2)
					{
						// Go button deaktivieren
						buttonEXE.setEnabled(false);
					}
					
					tag1.setEnabled(false);
					tag2.setEnabled(false);
					deltag1.setEnabled(false);
					deltag2.setEnabled(false);
					
										
					int maxValue2 = files.length;	// bestimme maximalwert fr progressbar
					threadit2 = maxValue2; 			// bestimme maximalwert fr threadschleife
					
					// indeterminate progressbar machen 
					progress.setIndeterminate(true);
					progress.setString("Retrieving Tag-Information...");
					
					emergency.setEnabled(true); //emergency button aktivieren bei jedem klick auf den radiobutton
					
					disableRBs();
					
					Thread runner2 = new Thread()
					{
						public void run()
						{
							for(int q=0;q<threadit2;q++)
							{
								try
								{
									// probiere funktion und msste eine form von artist+" - "+title zurckbekommen! 
									namemp3[q] = tag1tofilename(files[q]); // hier bekomme ich "artist - title" ohne endung
									
									// splitte den namen von namemp3[i]
									// und gibt eine leicht vernderte ausgabe an die liste zurck (namemp3temp[])
									// ist fr den user damit er den unterschied besser sehen kann
									// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
									Scanner scanner = new Scanner(namemp3[q]).useDelimiter(" - ");
									String artist = scanner.next();
									String title = scanner.next();
																
									namemp3temp[q] = "[" + artist + "]   -   [" + title + "]"; // stelle zuerst preview dar
									
									namemp3[q] = namemp3[q]+".mp3"; // fge erst hier die endung hinzu
									
									// wenns klappt, in liste ausgeben
									farbmodel.setElementAt(new ListItem(col1,namemp3temp[q]),q);
								}
								catch(Exception awdadawd) 
								// wenn splitten nicht geht, oder wenn fehler gekommen ist von der aufgerufenen methode 
								// soll er die meldung der methode ausgeben, AUSSERDEM muss der ursprngliche name
								// im namen[i] gespeichert werden sonst steht beim name nachher "Error: weil.mp3"
								{
									namemp3temp[q] = namemp3[q]; // fehlermeldung fr die ausgabe
									namemp3[q] = files[q].getName(); // ursprnglicher name muss wieder in namemp3[i] reinkommen
									
									// wo es nicht ging , farblich rot unterlegen
									farbmodel.setElementAt(new ListItem(col4,namemp3temp[q]),q);
								}														
								
								progress.setString("Retrieving Tag-Information..."+q);
								
								if(kanzler == 1)
			            		{
			            			break;	// wenn "stop" gedrckt wird soll die schleife abgebrochen werden
			            		}  
							}
							// nach dem "break"; bzw. nachdem die schleife fertig ist, soll er sofort wieder den kanzler 0 setzen
							emergency.setEnabled(false);
							kanzler = 0;
			            	logger.info("Letzter Wert von Kanzler = " +kanzler);
							
							progress.setString(null);
							progress.setIndeterminate(false);
							
							enableRBs();
						}
						
					};
					runner2.start();
				
					
				}
				else if(rb444.isSelected()==true)	// Show Tag ID3v2 RadioButton
				{
					// bei jedem wechsel von radiobutton zu radiobutton soll er die progressbar resetten
					progress.setValue(0);
					
					// nur auf der ID3 seite das machen!
					if(umschalter==2)
					{
						// Go button deaktivieren
						buttonEXE.setEnabled(false);
					}
					
					tag1.setEnabled(false);
					tag2.setEnabled(false);
					deltag1.setEnabled(false);
					deltag2.setEnabled(false);
					
					int maxValue2 = files.length;	// bestimme maximalwert fr progressbar
					threadit2 = maxValue2; 			// bestimme maximalwert fr threadschleife
					
					// indeterminate progressbar machen 
					progress.setIndeterminate(true);
					progress.setString("Retrieving Tag-Information...");
					
					emergency.setEnabled(true); //emergency button aktivieren bei jedem klick auf den radiobutton
					
					disableRBs();
					
					Thread runner2 = new Thread()
					{
						public void run()
						{
							for(int q=0;q<threadit2;q++)
							{
								try
								{
									// probiere funktion und msste eine form von artist+" - "+title zurckbekommen! 
									namemp3[q] = tag2tofilename(files[q]);
									
									// splitte den namen von namemp3[i]
									// und gibt eine leicht vernderte ausgabe an die liste zurck (namemp3temp[])
									// ist fr den user damit er den unterschied besser sehen kann
									// der wirkliche wert ist aber in namemp3[i] gespeichert, nicht in namemp3temp[i]
									Scanner scanner = new Scanner(namemp3[q]).useDelimiter(" - ");
									String artist = scanner.next();
									String title = scanner.next();
									namemp3temp[q] = "[" + artist + "]   -   [" + title + "]"; 
									
									namemp3[q] = namemp3[q]+".mp3"; // fge erst hier die endung hinzu
									
									// wenns klappt, in liste ausgeben
									farbmodel.setElementAt(new ListItem(col1,namemp3temp[q]),q);		
								}
								catch(Exception awdadawd) 
								// wenn splitten nicht geht, oder wenn fehler gekommen ist von der aufgerufenen methode 
								// soll er die meldung der methode ausgeben, AUSSERDEM muss der ursprngliche name
								// im namen[i] gespeichert werden sonst steht beim name nachher "Error: weil.mp3"
								{
									namemp3temp[q] = namemp3[q]; // fehlermeldung fr die ausgabe
									namemp3[q] = files[q].getName(); // ursprnglicher name muss wieder in namemp3[i] reinkommen
									
									// wo es nicht ging , farblich rot unterlegen
									farbmodel.setElementAt(new ListItem(col4,namemp3temp[q]),q);
								}						
								progress.setString("Retrieving Tag-Information..."+q);
								
								if(kanzler == 1)
			            		{
			            			break;	// wenn "stop" gedrckt wird soll die schleife abgebrochen werden
			            		}  
							}
							// nach dem "break"; bzw. nachdem die schleife fertig ist, soll er sofort wieder den kanzler 0 setzen
							emergency.setEnabled(false);
			            	kanzler = 0;
			            	logger.info("Letzter Wert von Kanzler = " +kanzler);
							
							progress.setString(null);
							progress.setIndeterminate(false);
							
							enableRBs();
						}
					};
					runner2.start();
				}
				else
				{
					// bei jedem wechsel von radiobutton zu radiobutton soll er die progressbar resetten
					progress.setValue(0);
					
					tag1.setEnabled(false);
					tag2.setEnabled(false);
					deltag1.setEnabled(false);
					deltag2.setEnabled(false);
				}
			}
		}
    };
    
    ItemListener ItemList = new ItemListener()
	{
		public void itemStateChanged(ItemEvent ie)
		{
			if(rb1.isSelected() == true)
			{
				//System.out.println("Skipmode chosen!");
			}
			else if(rb2.isSelected() == true)
			{
				//System.out.println("Namechangemode chosen!");
			}
		}
	};    
	
	
	class Actlist3 implements ActionListener
	{
		public void actionPerformed(ActionEvent actimel3)
		{
			label = actimel3.getActionCommand();
			
			if(files==null)
			{
				resetter(); // auch hier alle settings zurcksetzen
			}
			else	// RESET sollte a) nur die markierten dateien resetten, b) oder alle
			{
				if(nachgo == 1)
				{
					Toolkit.getDefaultToolkit().beep();
					JOptionPane.showMessageDialog(null,
							"You must either RELOAD the changed files first or CLEAR the filelist\n" +
							"in order to continue working!",
						    "Error",
						    JOptionPane.ERROR_MESSAGE);
				}			
				else
				{	
					
					Object[] selwieder = dateiliste2.getSelectedValues();
					int anzahlwieder = dateiliste2.getSelectedValues().length;
					
					if(anzahlwieder==0) // falls keine datei markiert ist, soll er ALLE Dateien und alle Settings resetten
					{
						for(int i=0;i<listenvektor.size();i++)
						{
							if(label.equals("RESET"))
							{
								namen[i] = listenvektor.get(i).toString(); // get "fresh" name
							}
							farbmodel.setElementAt(new ListItem(col1,namen[i]),i);
						}
						
						// alle GUi settings zurcksetzen
						resetter();
						
						// bei einem RESET muss der vernderte array im undomanager auch eingefgt werden, als neuer AUSGANGSPUNKT
						String[] endlich = namen.clone();
						System.arraycopy(namen,0,endlich,0,namen.length);
						undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
						
						
					}
					else	// falls dateien markiert sind, nur diese RESETTEN!!!
					{
						for(int i=0;i<selwieder.length;i++)
						{
							int pos2 = (int) farbmodel.indexOf(selwieder[i]); // bestimme zuerst die position die markiert ist
							
							if(label.equals("RESET"))
							{
								namen[pos2] = listenvektor.get(pos2).toString(); // get "fresh" name
							}
							farbmodel.setElementAt(new ListItem(col1,namen[pos2]),pos2);
						}
						// am schluss alle GUi settings zurcksetzen <= NICHT machen, sonst passieren fehler beim selektionsmodus!!!!
						resetter();
						
						// bei einem RESET muss der vernderte array im undomanager auch eingefgt werden, als neuer AUSGANGSPUNKT
						String[] endlich = namen.clone();
						System.arraycopy(namen,0,endlich,0,namen.length);
						undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
						
						
					}
				}
			}
		}
	}
		
	class Actlist4 implements ActionListener
	{
		public void actionPerformed(ActionEvent actimel4)
		{
			label = actimel4.getActionCommand();
			
			dateiliste2.clearSelection();// jede markierung weg, damit man die farblichen unterlufe sieht 
			
			if(files==null) 
			{
				
			}
			else if(files.length==0)
			{
				//falls die bedingung nicht da ist kommt bei X drcken und dann "Go!" => Exception
			}
			else
			{
				z = 0;			// mssen resetttet werden, weil wenn 2x hintereinander "execute gedrckt wird
				counter = 1; 	// mssen resetttet werden, weil wenn 2x hintereinander "execute gedrckt wird
				
				int maxValue = files.length;	// bestimme maximalwert fr progressbar
				progress.setMaximum(maxValue);
				threadit = maxValue; 			// bestimme maximalwert fr threadschleife
				
				emergency.setEnabled(true); //emergency button aktivieren bei jedem klick auf "go"
				
				disableRBs();
				
				if(umschalter == 1)
				{
					disablebutts();
					
					buttonEXE.setEnabled(false);
					buttonRELOAD.setEnabled(false);
					button99.setEnabled(false);
				}
				
				
				
				Thread runner = new Thread()
		        {
		            public void run() 
		            {
		               	for(int i=0;i<threadit;i++)
		            	{
		            		Runnable runme = new Runnable()
		            		{
		            			public void run()
		            			{
		            				if(label.equals("Equalize Tags!")) // equalize both tag-versions
		    						{
		    							try
		    							{
		    								MediaFile media = new MP3File(files[z]);
		    								
		    								ID3V1Tag id3v1 = media.getID3V1Tag();
		    								ID3V2Tag id3v2 = media.getID3V2Tag();
		    									
		    								if((id3v1 != null)&&(id3v2 == null))		// case Tag_v2 is NOT activated
		    								{
		    									if((!id3v1.getArtist().contentEquals(""))&&(!id3v1.getTitle().contentEquals(""))) // if ARTIST *and* TITLE in Tag_v1 are NOT empty
		    									{
		    										ID3V2_3_0Tag id3v2_n = new ID3V2_3_0Tag();	// activate Tag_v2
		    										id3v2_n.setArtist(id3v1.getArtist());		// put Tags from v1 into v2	
		    										id3v2_n.setTitle(id3v1.getTitle());
		    										
		    										media.setID3Tag(id3v2_n); 			
		    										media.sync();
		    										
		    										String ing = "ID3v1 = ID3v2";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    									else // if ARTIST *and/or* TITLE in Tag_v1 are empty
		    									{
		    										String ing = "ARTIST and/or TITLE field of ID3v1 is empty. File skipped!";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    								}
		    								else if((id3v1 == null)&&(id3v2 != null))	// case Tag_v1 is NOT activated
		    								{
		    									if((id3v2.getArtist() != null)&&(id3v2.getTitle()!= null)) // if ARTIST *and* TITLE in Tag_v2 are NOT empty
		    									{	
		    										ID3V1_0Tag id3v1_n = new ID3V1_0Tag();		// activate Tag_v1
		    										id3v1_n.setArtist(id3v2.getArtist());		// put Tags from v2 into v1		
		    										id3v1_n.setTitle(id3v2.getTitle());
		    										
		    										media.setID3Tag(id3v1_n); 									
		    										media.sync();
		    										
		    										String ing = "ID3v1 = ID3v2";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    									else // if ARTIST *and/or* TITLE in Tag_v2 are empty
		    									{
		    										String ing = "ARTIST and/or TITLE field of ID3v2 is empty. File skipped!";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    								}
		    								else if((id3v1 == null)&&(id3v2 == null))		// case Tag_v1 and Tag_v2 are NOT activated
		    								{
		    									String ing = "No ID3 version activated! Do 'Filename > Tag' first!";
		    									farbmodel.setElementAt(new ListItem(col3,ing),z);
		    								}
		    								else if((id3v2 != null)&&(id3v1 != null)) 		// case Tag_v1 and Tag_v2 are ACTIVATED 
		    								{
		    									if((!id3v1.getArtist().equals(id3v2.getArtist())) || (!id3v1.getTitle().equals(id3v2.getTitle())))	// if ARTIST *or* TITLE is NOT the same in both Tags 
		    									{
		    										if((id3v2.getArtist() == null) || (id3v2.getTitle() == null)) // ARTIST *and/or* TITLE in Tag_v2 are empty
		    										{
		    											if((!id3v1.getArtist().contentEquals(""))&&(!id3v1.getTitle().contentEquals("")))	// if ARTIST *and* TITLE in Tag_v1 are NOT empty
		    											{
		    												id3v2.setArtist(id3v1.getArtist());	// put ARTIST from Tag_v1 into Tag_v2
		    												id3v2.setTitle(id3v1.getTitle());	// put TITLE from Tag_v1 into Tag_v2
		    												media.setID3Tag(id3v2);
		    												media.sync();
		    																								
		    												String ing = "ID3v1 = ID3v2";
		    												farbmodel.setElementAt(new ListItem(col1,ing),z);
		    											}
		    											else	// ARTIST *and/or* TITLE in Tag_v1 are empty
		    											{
		    												String ing = "ARTIST and/or TITLE field of ID3v2 and/or ID3v1 are EMPTY! RETAG FIRST!";
		    												farbmodel.setElementAt(new ListItem(col1,ing),z);
		    											}
		    										}
		    										else	// ARTIST *and* TITLE in Tag_v2 are NOT empty
		    										{
		    											id3v1.setArtist(id3v2.getArtist());	// put ARTIST from Tag_v2 into Tag_v1
		    											id3v1.setTitle(id3v2.getTitle());	// put TITLE from Tag_v2 into Tag_v1
		    											media.setID3Tag(id3v1);
		    											media.sync();
		    											
		    											String ing = "ID3v1 = ID3v2";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    									}
		    									else // case ARTIST and TITLE in Tag_v1 equals Tag_v2
		    									{
		    										String ing = "ID3v1 = ID3v2";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    								}
		    								else
		    								{
		    									String ing = "Unknown Error: (Maybe Write Error) Please Send BugReport!";
		    									farbmodel.setElementAt(new ListItem(col3,ing),z);
		    								}
		    							}
		    							catch(Exception eeee)
		    							{
		    								String ing = "Error: No MP3-File!";
		    								farbmodel.setElementAt(new ListItem(col3,ing),z);
		    							}
		    							files3[z] = files[z];//RELOADER
		    						}
		            				

		     		               
		    						
		    						// ========================= TODO when pressing EXECUTE ==============================//
		    						
		    						if(label.equals("RUN!"))
		    						{
		    							// jetzt nur mal die MP3MODE			
		    									    							
		    							String vz = files[z].getParent()+"/"; // Slash hinzufgen, damit Verzeichnis erkannt wird
		    							//System.out.println("Das Verzeichnis ist " + vz"); //for debugging
		    							
		    							if(deltags.isSelected()==true)
		    							{
		    								try // ist ein mp3 file
		    								{
		    									MediaFile media = new MP3File(files[z]);
		    									
		    									// Teste, ob das MP3 berhaupt Tags hat mit nachfolgender If-Else Bedingung
		    									ID3V1Tag id3v1 = media.getID3V1Tag();
		    									ID3V2Tag id3v2 = media.getID3V2Tag();
		    									
		    									if((deltag1.isSelected()==true)&&(deltag2.isSelected()==true)) // beide tags lschen
		    									{
		    										// die if schleife skipt alle files, wo die ID3 schon deaktiviert sind!
		    										// geht schneller so :-)
		    										if(id3v1==null)
		    										{}
		    										else
		    										{	    										
			    										media.removeID3V1Tag();
			    										media.sync();
		    										}
		    										if(id3v2==null)
		    										{}
		    										else
		    										{	    										
			    										media.removeID3V2Tag();
			    										media.sync();
		    										}
		    										//media.removeTags();									
		    										//media.sync();		    										
		    										String ing = "Successfully deleted: ID3v1/2!";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    									else if((deltag1.isSelected()==true)&&(deltag2.isSelected()==false))// nur tag1 lschen
		    									{
		    										// die if schleife skipt alle files, wo die ID3 schon deaktiviert sind!
		    										// geht schneller so :-)
		    										if(id3v1==null)
		    										{}
		    										else
		    										{	    										
			    										media.removeID3V1Tag();
			    										media.sync();
		    										}
		    										String ing = "Successfully deleted: ID3v1 ONLY!";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    									else if((deltag1.isSelected()==false)&&(deltag2.isSelected()==true))// nur tag2 lschen
		    									{
		    										// die if schleife skipt alle files, wo die ID3 schon deaktiviert sind!
		    										// geht schneller so :-)
		    										if(id3v2==null)
		    										{}
		    										else
		    										{	    										
			    										media.removeID3V2Tag();
			    										media.sync();
		    										}
		    										String ing = "Successfully deleted: ID3v2 ONLY!";
		    										farbmodel.setElementAt(new ListItem(col1,ing),z);
		    									}
		    									else //nix angeklickt zum lschen
		    									{
		    										String ing = "Please select ID3 version being deleted!";
		    										farbmodel.setElementAt(new ListItem(col5,ing),z);
		    									}
		    								}
		    								catch(Exception hugo) // ist kein mp3 file
		    								{
		    									String ing = "No MP3 File!";
		    									farbmodel.setElementAt(new ListItem(col3,ing),z);
		    								}
		    								files3[z] = files[z];//RELOADER => get original filename (filename stays unchanged anyways!)
		    							}
		    							else if(rb222.isSelected()==true)
		    							{
		    								try
		    								{
		    									MediaFile media = new MP3File(files[z]);
		    									
		    									// Teste, ob das MP3 berhaupt Tags hat mit nachfolgender If-Else Bedingung
		    									ID3V1Tag id3v1 = media.getID3V1Tag();
		    									ID3V2Tag id3v2 = media.getID3V2Tag();
		    									
		    									Scanner scanner = new Scanner(namemp3[z]).useDelimiter(" - ");
		    									String artist = scanner.next();
		    									String title = scanner.next();
		    									
		    									
		    									if((tag1.isSelected()==true)&&(tag2.isSelected()==true)) // both checkboxes are selected
		    									{
		    										// Mp3 hat beide TagInstanzen aktiviert, aber bestimmte Felder sind bereits ausgefllt
		    										// Nur Artist und Title werden berschrieben, alle anderen Felder bleiben samt Inhalt erhalten
		    										if((id3v1 != null)&&(id3v2 != null))
		    										{
		    											id3v1.setArtist(artist);
		    											id3v1.setTitle(title);
		    											media.setID3Tag(id3v1);
		    											
		    											id3v2.setArtist(artist);
		    											id3v2.setTitle(title);
		    											media.setID3Tag(id3v2);
		    											
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v1/2!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    										else if((id3v1 != null)&&(id3v2 == null))
		    										{
		    											id3v1.setArtist(artist);
		    											id3v1.setTitle(title);
		    											media.setID3Tag(id3v1);
		    											
		    											ID3V2_3_0Tag id3v2_n = new ID3V2_3_0Tag();
		    											id3v2_n.setArtist(artist);
		    											id3v2_n.setTitle(title);
		    											media.setID3Tag(id3v2_n);
		    											
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v1/2!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    										else if((id3v1 == null)&&(id3v2 != null))
		    										{
		    											ID3V1_0Tag id3v1_n = new ID3V1_0Tag();
		    											id3v1_n.setArtist(artist);
		    											id3v1_n.setTitle(title);
		    											media.setID3Tag(id3v1_n);
		    											
		    											id3v2.setArtist(artist);
		    											id3v2.setTitle(title);
		    											media.setID3Tag(id3v2);
		    											
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v1/2!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    										
		    										// Mp3 hat berhaupt keine Tags aktiviert => erzeuge neue leere TagInstanzen
		    										else
		    										{
		    											ID3V1_0Tag id3v1_n = new ID3V1_0Tag();
		    											id3v1_n.setArtist(artist);
		    											id3v1_n.setTitle(title);
		    											media.setID3Tag(id3v1_n);
		    																	
		    											ID3V2_3_0Tag id3v2_n = new ID3V2_3_0Tag();
		    											id3v2_n.setArtist(artist);
		    											id3v2_n.setTitle(title);
		    											media.setID3Tag(id3v2_n);
		    											
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v1/2!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    									}
		    									else if((tag1.isSelected()==true)&&(tag2.isSelected()==false))// only checkbox 1 is selected
		    									{
		    										if(id3v1 != null) // tag activated
		    										{
		    											id3v1.setArtist(artist);
		    											id3v1.setTitle(title);
		    											media.setID3Tag(id3v1);
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v1 ONLY!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    										else // tag deactivated
		    										{
		    											ID3V1_0Tag id3v1_n = new ID3V1_0Tag();
		    											id3v1_n.setArtist(artist);
		    											id3v1_n.setTitle(title);
		    											media.setID3Tag(id3v1_n);
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v1 ONLY!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    									}
		    									else if((tag1.isSelected()==false)&&(tag2.isSelected()==true))// only checkbox 2 is selected
		    									{
		    										if(id3v2 != null) // tag activated
		    										{
		    											id3v2.setArtist(artist);
		    											id3v2.setTitle(title);
		    											media.setID3Tag(id3v2);
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v2 ONLY!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    										else // tag deactivated
		    										{
		    											ID3V2_3_0Tag id3v2_n = new ID3V2_3_0Tag();
		    											id3v2_n.setArtist(artist);
		    											id3v2_n.setTitle(title);
		    											media.setID3Tag(id3v2_n);
		    											media.sync();
		    											
		    											String ing = "Successful: Filename to ID3v2 ONLY!";
		    											farbmodel.setElementAt(new ListItem(col1,ing),z);
		    										}
		    									}
		    									else // no checkbox is activated
		    									{
		    										String ing = "Please select ID3 version being tagged!";
		    										farbmodel.setElementAt(new ListItem(col5,ing),z);
		    									}
		    								}
		    								catch(Exception eeee)
		    								{
		    									String ing = "No MP3 file / filename doesn't match pattern!";
		    									farbmodel.setElementAt(new ListItem(col3,ing),z);
		    								}
		    								files3[z] = files[z];//RELOADER => get original filename (filename stays unchanged anyways!)
		    							}
		    							else // wenn nur namen gendert wurden (mp3 mode DEAKTIVIERT)
			    						{
	    									if // test ob verbotene zeichen im namen drin sind
		    								(
		    										namen[z].contains("/")||
		    										namen[z].contains("\\")||
		    										namen[z].contains(":")||
		    										namen[z].contains("\"")||
		    										namen[z].contains(">")||
		    										namen[z].contains("<")||
		    										namen[z].contains("|")||
		    										namen[z].contains("%")||
		    										namen[z].contains("*")||
		    										namen[z].contains("?")	
		    								)
		    								{
		    									
		    									files3[z] = files[z]; // RELOADER (mit originalname)
		    									
		    									farbmodel.setElementAt(new ListItem(col6,namen[z]),z); // rot unterlegen
		    									//logger.info("Originalname: "+files3[z]);
		    								} 								
		    								
		    								else
		    								{
		    								
			    								// SKIPMODE!!!
					    						if(rb1.isSelected()==true)
					    						{
					    							vz = files[z].getParent()+"/"; // Slash hinzufgen, damit Verzeichnis erkannt wird
					    							
					    							//output("Das Verzeichnis ist " + vz + "\n",def); //for debugging
					    							
					    							File f1 = new File(vz+namen[z]); // Erstellt 'Kopie' der Datei im selben Verzeichnis wie Quelldatei
					    							if(files[z].renameTo(f1)==true)
					    							{
					    								files[z].renameTo(f1);
					    								
					    								//output("CHANGED TO: " + f1 + "\n",s2); // gibt zustzlich Pfad der Datei aus, for debugging
					    								
					    								farbmodel.setElementAt(new ListItem(col2,f1.getName()),z); // bei erfolg, namen in grn hinschreiben
					    								
					    								
					    								files3[z] = f1;//RELOADER
					    							}
					    							else
					    							{
					    								files3[z] = files[z];//RELOADER
					    								
					    								String ing = "Filename already exists! SKIPPED";
					    								farbmodel.setElementAt(new ListItem(col3,ing),z); // bei misserfolg wegen doppelten dateinamen und +
					    							}
					    						}
			    								
					    						else if(rb2.isSelected()==true)
					    						{
					    							
					    							File f1 = new File(vz+namen[z]); // Erstellt 'Kopie' der Datei im selben Verzeichnis wie Quelldatei
				    								if(files[z].renameTo(f1)==true)
				    								{
				    									files[z].renameTo(f1);
				    									
				    									//output("CHANGED TO: " + f1 + "\n",s2); // gibt zustzlich Pfad der Datei aus, for debugging									
				    									
				    									files3[z] = f1; // RELOADER
				    									
				    									farbmodel.setElementAt(new ListItem(col2,f1.getName()),z); // bei erfolg, namen in grn hinschreiben
				    								}
				    								else
				    								{
				    								
				    									String ncm = "_";
				    									File f2 = null;
				    									
				    									// this function adds an amount of "_" at the beginning of
				    									// of each filename, which is double/triple or more
				    									// for as long as it can't be renamed!
				    									for(;;)
				    									{
				    										//TODO wenn datei abgespielt wird gleichzeitig: datei hngt hier in endlos schleife fest, weil
				    										// er nie umbenennen kann, ausser das lied ist endlich fertig gespielt
				    										
				    										// this function "f2 = new File(vz+ncm+namen[z]);" also puts one or more "_" at the beginning
				    										// of files where filename is empty (""), as possible with the function "kill chars from left"
				    										f2 = new File(vz+ncm+namen[z]);
				    										if(files[z].renameTo(f2)==false)
				    										{
				    											ncm = ncm+"_";
				    											renamecounter++;
				    											logger.info("renamecounter: "+renamecounter);
				    										}
				    										else
				    										{
				    											files[z].renameTo(f2);
				    											renamecounter = 0;
				    											
				    											farbmodel.setElementAt(new ListItem(col3,f2.getName()),z); // bei misserfolg und erfolgreicherumebnenenung
						    									files3[z] = f2;//RELOADER
				    											break;									
				    										}
				    										
				    										// wenn der wert 50 erreicht ist wird
				    										// 1. schleife abgebrochen
				    										// 2. der originalfilename im reloader gespeichert
				    										if(renamecounter == 50) 
				    										{
				    											renamecounter = 0;
				    											
				    											farbmodel.setElementAt(new ListItem(col6,namen[z]),z); // wenn file in use ist z.b. im mediaplayer grad spielt
						    									files3[z] = files[z];//RELOADER holt originalfile
				    											break;				    											
				    										}
				    									}
				    								}
					    						}
					    						
					    						// bei den mp3 funktionen soll er den "nachgo" NICHT auf 1 setzen, sondern 0 bleiben
					    						// er soll den schalter "nachgo" 1 setzen, wenn NUR namen gendert wurden;
					    		            	nachgo = 1;
					    		            	
					    		            	//er soll tabpane 1 deaktivieren solang nicht reload gemacht wurde
					    		            	tabpane.setEnabledAt(1,false);
					    		            	
					    		            	
			    							}
			    						}
		    						}
		            				
		            				// hier kommt rein alle funktionen der schleife und der counter
		            				// System.out.println("alle meine entchen an der Stelle " + z);
		            				progress.setValue(counter); // gilt nur fr die % anzeige beim balken
		            				counter++;
				            		z++;
				            		
				            		
		            			}
		            		};
		            		try
		            		{
		            			// das bewirkt,dass wirklich die %  nach jedem umbenannten angezeigt wird!
		            			// und nicht dass sprnge von 14% auf 26% o.. gemacht werden!
		            			SwingUtilities.invokeAndWait(runme); 
		            		}
		            		catch (Exception ex) 
		            		{}
		            		
		            		//logger.info("wert von kanzler ist " + kanzler);
		            		
		            		if(kanzler == 1)
		            		{
		            			// diese funktion speichert alle restlichen, noch nicht vernderten dateien im reloader
		            			// sodass nach einem "Cancel" alle files reloadet werden knnen
		            			for(int restliche=z;restliche<threadit;restliche++,z++)
		            			{
		            				files3[restliche] = files[z];// Originalnamen herholen fr Reloader
		            				//logger.info(files3[restliche]);
		            			}
		            			
		            			break;	// wenn "stop" gedrckt wird soll die schleife abgebrochen werden
		            		}  		            		
		            		
		            	}
		            	// nach dem "break"; bzw. nachdem die schleife fertig ist, soll er sofort wieder den kanzler 0 setzen
		            	emergency.setEnabled(false);
		            	kanzler = 0;
		            	logger.info("Letzter Wert von Kanzler = " +kanzler);
		            	
		            	
		            	if(umschalter == 1)
		            	{
		            		enablebutts();
		            		
		            		//buttonEXE.setEnabled(true); // erst beim reload oder clear wieder enablen
							buttonRELOAD.setEnabled(true);
							button99.setEnabled(true);
		            	}
		            	
		            	// wenn break/Go! gemacht wurde und der ID3 /mp3 tab aktiviert ist
		            	// soll er alle schaltflchen wieder freimachen (die radiobuttons)
		            	if(umschalter == 2)
		            	{
		            		enableRBs();
		            	}
		            	
		            	
	            		 /*
	            		  *	AUTO-RELOADER funktion!
	            		  */
	            		
	            		if((item2a.isSelected()==true) &&(progress.getPercentComplete()==1.0))
	    		        {
	    		        	buttonRELOAD.setEnabled(false); //RELOAD button muss deaktiviert bleiben
	    		        	//try{Thread.sleep(250); //250 millisekunden warten, bevor reload passiert
	    		        	//}catch(Exception machhinne){}
	    		        	reload_teh_files();
	    		        }
	    		        else	// AUTO-RELOADER deaktiviert
	    		        {
	    		        
	    			        buttonRELOAD.setEnabled(true); //aktiviere RELOAD button, sobald 1x RUN gemacht wurde
	    			        //buttonRES.setEnabled(false); // De-aktiviere RESET button, sobald 1x RUN gemacht wurde
	    		        }
	    		        //System.out.println(progress.getPercentComplete()); // bei 1.0 ist er fertig, entsrpicht 100%
		            	
		            }
		        };
		        runner.start();
		        		        
		    }
			clearundomanager(); // lsche undo/redo arrays nach jedem GO
			
					
		}
	}
	
	public void disablebutts()
	{
		
		eins.setEnabled(false);
		zwo.setEnabled(false);
		drei.setEnabled(false);
		vier.setEnabled(false);
		trimmer.setEnabled(false);
		button1.setEnabled(false);
		button111.setEnabled(false);
		button4.setEnabled(false);
		artistprev.setEnabled(false);
		cbx1.setEnabled(false);
		deli1.setEnabled(false);
		deli2.setEnabled(false);
		garfield1.setEnabled(false);
		garfield2.setEnabled(false);
		dashrenamer.setEnabled(false);
		
		rem.setEnabled(false);
		undo.setEnabled(false);
		redo.setEnabled(false);
		buttonRES.setEnabled(false);
	}
	
	public void enablebutts()
	{
		
		eins.setEnabled(true);
		zwo.setEnabled(true);
		drei.setEnabled(true);
		vier.setEnabled(true);
		trimmer.setEnabled(true);
		button1.setEnabled(true);
		button111.setEnabled(true);
		button4.setEnabled(true);
		artistprev.setEnabled(true);
		cbx1.setEnabled(true);
		deli1.setEnabled(true);
		deli2.setEnabled(true);
		garfield1.setEnabled(true);
		garfield2.setEnabled(true);
		dashrenamer.setEnabled(true);
		
		rem.setEnabled(true);
		undo.setEnabled(true);
		redo.setEnabled(true);
		buttonRES.setEnabled(true);
	}
	
	// ActionListener fr GUI 
	class Actlist implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{			
			label = e.getActionCommand();
			if(label.equals("CL SEL"))
			{
				dateiliste2.clearSelection(); // alles wird deselektiert
				dateiliste.clearSelection();
			}
			if(label.equals("Exit"))
			{
				System.exit(0);
			}
			if(label.equals("About"))
			{
				new SubDialog();
				return;
			}
			if(label.equals("CLEAR"))
			{
				clearall();
			}			
						
			if(label.equals("RELOAD"))
			{
				reload_teh_files();
			}
		}
	}
	
	
	public void clearall()
	{
		nachgo = 0;
		
		//er soll tabpanes wieder AKTIVIEREN
    	enableRBs();
    	
    	if(umschalter == 1)
    	{
    		buttonEXE.setEnabled(true);
    	}
    	
    	switchnurid = 0; // da wird das kennezichen fr tagauslesen wieder 0 gesetzt
    	
		clearundomanager(); //Resette UNDO/REDO zuerst
		// nach jedem CLEAR auch die die ID3 buttons zurcksetzen
		rb111.setSelected(true);
		mp3Listener.itemStateChanged(mpe);
		
		if(files == null)
		{
			namen = null;
			files3 = null;
			
			listenvektor.clear();
			dateipfad.clear();
			pfadliste.repaint();
			dateiliste.repaint();
			farbmodel.clear();
			
			progress.setValue(0); // reset progressbar
			
			buttonRELOAD.setEnabled(false); //deaktiviere RELOAD button
			
			// anzahl files die geladen sind
			counterlab.setText("Files loaded: "+listenvektor.size());
			
			//reset GUI
			resetter();
		}
		else
		{
			files = null;
			namen = null;
			files3 = null;
			
			listenvektor.clear();
			dateipfad.clear();
			pfadliste.repaint();
			dateiliste.repaint();
			farbmodel.clear();
			
			buttonRELOAD.setEnabled(false); //deaktiviere RELOAD button
			
			progress.setValue(0); // reset progressbar
			
			// anzahl files die geladen sind
			counterlab.setText("Files loaded: "+listenvektor.size());
			
			//reset GUI
			resetter();
		}					
	}
	
	public void reload_teh_files()	//RELOAD gekapselt in funktion
	{       
		
		nachgo = 0;
		
		//er soll tabpanes wieder AKTIVIEREN
    	enableRBs();
		
    	
    	if(umschalter == 1)
    	{
    		buttonEXE.setEnabled(true);
    	}
    	
       // System.out.println("\nfiles: " + files.length);
        //System.out.println("\nfiles3: " + files3.length);
        //System.out.println("\nnamen: " + namen.length);
        
       // for(int i=0;i<files3.length;i++)
		//{
        	//System.out.println("\nfiles3 an Stelle "+i+ "ist: "+ files3[i]);
		//}
		
		// Das bewirkt dass der RELOAD button NUR bei Tab1 (simple) funktioniert
		// bei TAb2 wird der filenamen ja nicht verndert!
		if(umschalter==1)
		{      
			if(files != null)
			{
				files = null; // zuerst alles aus files lschen
				files = new File[files3.length]; // dann arraygre neu initialisieren
				namen = null; // zuerst alles aus namen lschen
				namen = new String[files3.length]; // dann arraygre neu initialisieren
				
				listenvektor.clear();
				dateipfad.clear();
				pfadliste.repaint();
				dateiliste.repaint();
				//farbmodel.clear(); //ausmarkiert, weil sonst excpetion beim selection modus kommt
				farbmodel.setSize(files3.length);
				
				progress.setValue(0); // reset progressbar
							
				//namen[i] = null;
						
				// der fehler liegt am nachfolgenden teild es action listeners, wo die restlichen buttons sind
				
					for(int i=0;i<files3.length;i++)
					{
						//System.out.println("RELOADED Path is: "+files3[i]); // for debugging: shows path of new file
						files[i] = files3[i]; // flle files[] inhalt mit dem von files3[]
						
						namen[i] = files[i].getName(); // flle namen-array mit Daten aus filearray, aber nur dateiname
						listenvektor.add(namen[i]);	// flle liste1 mit den namen[]
						dateipfad.add(files[i].toString());	// flle GeisterVektor mit filepfaden[]
						farbmodel.setElementAt(new ListItem(col1,namen[i]),i); // flle liste2 mit den namen[]
					}
					pfadliste.setListData(dateipfad); // setze geistervektor in liste ein
					pfadliste.repaint();
					dateiliste.setListData(listenvektor); // setze listenvektor ein in die liste
					dateiliste.repaint();
					
					// anzahl files die geladen sind
					counterlab.setText("Files loaded: "+listenvektor.size());
					
					// nur wenn simple tab angewhlt ist soll folgendes machen
					if(umschalter==1)
					{
						// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
						listener123.itemStateChanged(einszwodrei);
					}					
					
					clearundomanager(); // lsche undo/redo arrays
					// bei einem RELOAD muss der vernderte array im undomanager auch eingefgt werden, als neuer AUSGANGSPUNKT
					String[] endlich = namen.clone();
					System.arraycopy(namen,0,endlich,0,namen.length);
					undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager
					
					// er muss zuerst alle selections deaktivieren, sonst werden beim reload nur bei den markierten
					// die underscores und whitespaces weggetan
					dateiliste2.clearSelection();
					
					//alles resetten auch bei ID3
					resetter();
					
					
					//am schluss sollte er den button wieder deaktiveren eigentlich..., oder den reloader 0 setzen
					buttonRELOAD.setEnabled(false);
				}
		}
		else
		{
			logger.info("No files available for reload.");
		}
	}
	
	public List textURIListToFileList(String data)
	{
		List list = new ArrayList(1);
		for (StringTokenizer st = new StringTokenizer(data, "\r\n"); st.hasMoreTokens();)
		{
			String s = st.nextToken();
			if (s.startsWith("#"))
			{
				// the line is a comment (as per the RFC 2483)
				continue;
			}
			try 
			{
				URI uri = new URI(s);
				File file = new File(uri);
				list.add(file);
			}
			catch (URISyntaxException e)
			{
				e.printStackTrace();
			}
			catch (IllegalArgumentException e) 
			{
				e.printStackTrace();
			}
		}
		return list;
	}
		
	// --------------------- Interface DropTargetListener ---------------------
		
	public void dragEnter(DropTargetDragEvent event) 
	{
		event.acceptDrag(DnDConstants.ACTION_COPY);
	}
	public void dragOver(DropTargetDragEvent event) {}
	public void dropActionChanged(DropTargetDragEvent event) {}
	public void dragExit(DropTargetEvent event) {}
	public void drop(DropTargetDropEvent event) 
	{
		if((nachgo == 1)&&(item2c.isSelected()!=true)) // wenn nachgo=1 ist und wenn "1 Time D&D" NICHT aktiviert sein sollte
		{
			Toolkit.getDefaultToolkit().beep();
			JOptionPane.showMessageDialog(null,
					"You must either RELOAD the changed files first or CLEAR the filelist\n" +
					"in order to continue working!",
				    "Error",
				    JOptionPane.ERROR_MESSAGE);
		}			
		else 
		{
			Transferable transferable = event.getTransferable();
			DefaultListModel model = new DefaultListModel();
			event.acceptDrop(DnDConstants.ACTION_COPY);
			DataFlavor uriListFlavor = null;
				
			try
			{
				uriListFlavor = new DataFlavor(URI_LIST_MIME_TYPE);
			}
			catch (ClassNotFoundException e)
			{
				e.printStackTrace();
			}
			
			
			
				try 
				{
					// for windows
					if (transferable.isDataFlavorSupported(DataFlavor.javaFileListFlavor)) 
					{
						List data = (List)transferable.getTransferData(DataFlavor.javaFileListFlavor);
						for (Object o : data) 
						{
							model.addElement(o);
						
						
						}
						
						// entfernt textarea und fgt scroller2 hinzu
						if(infoindex == 1)
						{
							bo.remove(scrollertemp);
							bo.add(scroller2);
							
							//bo = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,scroller2,scroller);		
							bo.setOneTouchExpandable(true);
							bo.setResizeWeight(0.5);
							bo.setDividerSize(5);
							
							c.gridx = 1; 
							c.gridy = 0;
							c.gridheight = 1;
							c.weightx = 1.0; // soll in der breite und
							c.weighty = 1.0; // in der hhe scalen
							gridbagpanel.add(bo,c);
						}
						infoindex = 2;
						
						
						
						/*
						 * Funktion geht von oben nach unten durch; sobald 1-time drops aktiviert ist, durchluft
						 * er aber zustzlich die if-bedingung, wo er die liste bei jedem neuen drop null setzt
						 */					
						if(item2c.isSelected()==true) 
						{
							clearall();
							/*
							dateipfad.clear();
							listenvektor.clear();
							farbmodel.clear();
							listenvektor.setSize(0);
							dateipfad.setSize(0);
							li = new ListItem[0];
							*/
						}					
						progress.setValue(0);
						
						int anzahl = data.size();
							
						// Diese Funktion fgt die drops in eine Liste ein und erweitert diese
						try
					  	{
							li = new ListItem[data.size()];
							for(int j=0;j<data.size();j++)
							{
								File f = (File)data.get(j); // beinhaltet den gesamten pfad der datei!
								
								dateipfad.add(f.toString());	// speichert den gesamten dateipfad!!! = GEISTERVEKTOR
								listenvektor.add(f.getName());	// das speichert NUR den dateinamen!!! in listenvektor1
								//listenvektor2.add(f.getName());	// das speichert NUR den dateinamen!!! in listenvektor2
								
								li[j] = new ListItem(new Color(240,240,240),f.getName());
								farbmodel.addElement(li[j]);
							}
							dateiliste.setListData(listenvektor);
							//dateiliste2.setListData(listenvektor2);
							pfadliste.setListData(dateipfad); // = GEISTERLISTE
							
						}
						catch(Exception fuck)
						{
							fuck.printStackTrace();
						}				
						
						dateiliste.setCellRenderer(new StripeRenderer());
						
						// vergleich durchfhren bei allen vorhandenen eintrgen ob welche doppelt sind
						// und die doppelten rausschmeissen
						
						LinkedHashSet hs = new LinkedHashSet(); // beim linked hashset, kommen die neuesten drops immer unten angefgt :)
						
						for(int m=0;m<listenvektor.size();m++)
						{
							hs.add(dateipfad.get(m).toString());
						}	
						Iterator i = hs.iterator();
						logger.info(hs.size());
						
						// erst jetzt sollte alles in namen[], files[], listenvektor, dateipfad etc. gespeichert werden!!!
						listenvektor.setSize(hs.size());listenvektor.clear(); 	// listengre
						dateipfad.setSize(hs.size());dateipfad.clear();			// listengre
						farbmodel.clear();li = new ListItem[hs.size()];		// reset und neue listengre
						
						for(int n=0;i.hasNext();n++)
						{					
							String hastri = i.next().toString();
							//System.out.println(hastri);			// print what is in hashset :-) // it is the complete filepath
							
							File feivel = new File(hastri);
							listenvektor.add(feivel.getName());	// das speichert NUR den dateinamen!!! in listenvektor1
							dateipfad.add(hastri);				// speichert ganzen pfad in geisterliste
							
							li[n] = new ListItem(Color.WHITE,feivel.getName());
							farbmodel.addElement(li[n]);		// fgt elemente zur liste 2 hinzu
						}				
						
						
						// Hole mir alle Dateinamen
						namen = new String[listenvektor.size()];			// erstelle namen[] Array der Gre listenvektor.size()			
						li = new ListItem[listenvektor.size()];				// erstelle li[] Array der Gre listenvektor.size();
						
						for(int k=0;k<listenvektor.size();k++)
						{
							li[k] = (ListItem) farbmodel.getElementAt(k);	// hole ListItem an entsprechendem Index
							namen[k] = li[k].getValue();		// 2. Wert im ListItem auslesen un im namen[] Array speichern
							//System.out.println(namen[k]); // for debugging only
						}
						
						// Hole mir alle Dateien selbst
						files = new File[listenvektor.size()];
						
						for(int k=0;k<listenvektor.size();k++)
						{
							files[k] = new File(dateipfad.get(k).toString());	// Speichere ListenInhalt in files[] Array
						}
						
						// Initialisiere Array fr RELOADER
						files3 = new File[listenvektor.size()];
						
						// anzahl files die geladen sind
						counterlab.setText("Files loaded: "+listenvektor.size());
						
						// nur wenn simple tab angewhlt ist soll folgendes machen
						if(umschalter==1)
						{
							// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
							listener123.itemStateChanged(einszwodrei);
						}					
						
						if(umschalter==1)
						{
							// erstelle array fr den undomanager
							clearundomanager(); //Resette UNDO/REDO zuerst
							String[] endlich = namen.clone();
							System.arraycopy(namen,0,endlich,0,namen.length);
							undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager	
						}		
						
						// nach jedem DROP auch die die ID3 buttons zurcksetzen
						rb111.setSelected(true);
						mp3Listener.itemStateChanged(mpe);
						
					}
					
					// for linux
					else if (transferable.isDataFlavorSupported(uriListFlavor)) 
					{
						String data = (String) transferable.getTransferData(uriListFlavor);
						List data2 = textURIListToFileList(data);
						for (Object o : data2)
						{
							model.addElement(o);
						}
						
						// entfernt textarea und fgt scroller2 hinzu
						if(infoindex == 1)
						{
							bo.remove(scrollertemp);
							bo.add(scroller2);
							
							//bo = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,scroller2,scroller);		
							bo.setOneTouchExpandable(true);
							bo.setResizeWeight(0.5);
							bo.setDividerSize(5);
							
							c.gridx = 1; 
							c.gridy = 0;
							c.gridheight = 1;
							c.weightx = 1.0; // soll in der breite und
							c.weighty = 1.0; // in der hhe scalen
							gridbagpanel.add(bo,c);
						}
						infoindex = 2;
						
						/*
						 * Funktion geht von oben nach unten durch; sobald 1-time drops aktiviert ist, durchluft
						 * er aber zustzlich die if-bedingung, wo er die liste bei jedem neuen drop null setzt
						 */					
						if(item2c.isSelected()==true) 
						{
							clearall();
							/*
							dateipfad.clear();
							listenvektor.clear();
							farbmodel.clear();
							listenvektor.setSize(0);
							dateipfad.setSize(0);
							li = new ListItem[0];
							*/
						}					
						progress.setValue(0);
						
						int anzahl = data2.size();
						
						// Diese Funktion fgt die drops in eine Liste ein und erweitert diese
						try
					  	{
							li = new ListItem[data2.size()];
							for(int j=0;j<data2.size();j++)
							{
								File f = (File)data2.get(j); // beinhaltet den gesamten pfad der datei!
								
								dateipfad.add(f.toString());	// speichert den gesamten dateipfad!!!
								listenvektor.add(f.getName());	// das speichert NUR den dateinamen!!! in listenvektor1
								//listenvektor2.add(f.getName());	// das speichert NUR den dateinamen!!! in listenvektor2
								
								li[j] = new ListItem(new Color(240,240,240),f.getName());
								farbmodel.addElement(li[j]);
							}
							dateiliste.setListData(listenvektor);
							//dateiliste2.setListData(listenvektor2);
							pfadliste.setListData(dateipfad);
							
						}
						catch(Exception fuck)
						{
							fuck.printStackTrace();
						}				
						
						dateiliste.setCellRenderer(new StripeRenderer());
						
						// vergleich durchfhren bei allen vorhandenen eintrgen ob welche doppelt sind
						// und die doppelten rausschmeissen
						LinkedHashSet hs = new LinkedHashSet(); // beim linked hashset, kommen die neuesten drops immer unten angefgt :)
						
						for(int m=0;m<listenvektor.size();m++)
						{
							hs.add(dateipfad.get(m).toString());
						}	
						Iterator i = hs.iterator();
						logger.info(hs.size());
						
						// erst jetzt sollte alles in namen[], files[], listenvektor, dateipfad etc. gespeichert werden!!!
						listenvektor.setSize(hs.size());listenvektor.clear(); 	// listengre
						dateipfad.setSize(hs.size());dateipfad.clear();			// listengre
						farbmodel.clear();li = new ListItem[hs.size()];		// reset und neue listengre
						
						for(int n=0;i.hasNext();n++)
						{					
							String hastri = i.next().toString();
							logger.info(hastri);			// print what is in hashset :-) // it is the complete filepath
							
							File feivel = new File(hastri);
							listenvektor.add(feivel.getName());	// das speichert NUR den dateinamen!!! in listenvektor1
							dateipfad.add(hastri);				// speichert ganzen pfad in geisterliste
							
							li[n] = new ListItem(Color.WHITE,feivel.getName());
							farbmodel.addElement(li[n]);		// fgt elemente zur liste 2 hinzu
						}				
						
						// Hole mir alle Dateinamen
						namen = new String[listenvektor.size()];			// erstelle namen[] Array der Gre listenvektor.size()			
						li = new ListItem[listenvektor.size()];				// erstelle li[] Array der Gre listenvektor.size();
						
						for(int k=0;k<listenvektor.size();k++)
						{
							li[k] = (ListItem) farbmodel.getElementAt(k);	// hole ListItem an entsprechendem Index
							namen[k] = li[k].getValue();		// 2. Wert im ListItem auslesen un im namen[] Array speichern
						}
						
						// Hole mir alle Dateien selbst
						files = new File[listenvektor.size()];
						
						for(int k=0;k<listenvektor.size();k++)
						{
							files[k] = new File(dateipfad.get(k).toString());	// Speichere ListenInhalt in files[] Array
						}
						
						// Initialisiere Array fr RELOADER
						files3 = new File[listenvektor.size()];
						
						// anzahl files die geladen sind
						counterlab.setText("Files loaded: "+listenvektor.size());
						
						// nur wenn simple tab angewhlt ist soll folgendes machen
						if(umschalter==1)
						{
							// bewirkt dass alle die dazugefgt werden, gleich whitespaces,underscores, quotes weghaben :-)
							listener123.itemStateChanged(einszwodrei);
						}					
						
						if(umschalter==1)
						{
							// erstelle array fr den undomanager
							clearundomanager(); //Resette UNDO/REDO zuerst
							String[] endlich = namen.clone();
							System.arraycopy(namen,0,endlich,0,namen.length);
							undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager	
						}		
						
						
						// nach jedem DROP auch die die ID3 buttons zurcksetzen
						rb111.setSelected(true);
						mp3Listener.itemStateChanged(mpe);
					}
				}
				catch (Exception e) 
				{
					e.printStackTrace();
				}
				//setModel(model);
				
		}

	}
	
	// ======================== Funktion zum rausnehmen von dateien aus der liste ======== TODO nur jumppunkt 
	public void deleteSelectedValueInList()
	{
		Object[] rSelected = dateiliste2.getSelectedValues();
		int[] selin = new int[rSelected.length];
		
		for(int j=0;j<rSelected.length;j++)
		{
			int pos_r = (int) farbmodel.indexOf(rSelected[j]); // bestimme position der selektierten in liste2
				
			selin[j] =  pos_r; // packe alle indeces der selektierten dateien in array**
		}
		dateiliste.setSelectedIndices(selin);//** selektiere mit dem array nun auch alle in der ersten liste
				
		Object[] selected111 = dateiliste.getSelectedValues();	 // hole die values
		
		for(int k=0;k<selin.length;k++)
		{
			int pos_r2 = (int) listenvektor.indexOf(selected111[k]);
			listenvektor.remove(selected111[k]); // remove die die selektierten aus liste1
			farbmodel.remove(pos_r2);		// entferne eintrag aus farbmodel (liste2)
			dateipfad.remove(pos_r2);		// entferne eintrag aus geisterliste
		}		
		dateiliste.repaint();
		//dateiliste2.repaint();
		dateiliste.updateUI(); // bewirkt dass kein scrollbarfehler kommt, kein "sprung" durch die vektorzeilen, die gelscht wurden
		pfadliste.repaint();
		
		//die liste sollte nach dem entfernen so gepaintet werden, dass nix mehr markiert ist 
		dateiliste.removeSelectionInterval(0,listenvektor.size());
		
		logger.info("\n" + listenvektor.size() + "\t" + farbmodel.size() + "\t" + dateipfad.size());
		
		
		// Hole mir alle Dateinamen neu, da Liste verndert wurde
		namen = new String[listenvektor.size()];			// erstelle namen[] Array der Gre listenvektor.size()			
		li = new ListItem[listenvektor.size()];				// erstelle li[] Array der Gre listenvektor.size();
		
		for(int k=0;k<listenvektor.size();k++)
		{
			li[k] = (ListItem) farbmodel.getElementAt(k);	// hole ListItem an entsprechendem Index
			namen[k] = li[k].getValue();	// 2. Wert im ListItem auslesen un im namen[] Array speichern
		}
		
		logger.info("Anzahl namen: "+namen.length);
		
		// Hole mir alle Dateien selbst wieder
		files = new File[listenvektor.size()];
		
		for(int k=0;k<listenvektor.size();k++)
		{
			files[k] = new File(dateipfad.get(k).toString());	// Speichere ListenInhalt in files[] Array
		}
		
		// Re-Initialisiere Array fr RELOADER
		files3 = new File[listenvektor.size()];
		
		if(umschalter==1)
		{
			// erstelle array fr den undomanager
			clearundomanager(); //Resette UNDO/REDO zuerst
			String[] endlich = namen.clone();
			System.arraycopy(namen,0,endlich,0,namen.length);
			undomanager(endlich);	// nach jeder nderung bergebe den genderten namen array dem undomanager	
		}		
		
		// anzahl files die geladen sind
		counterlab.setText("Files loaded: "+listenvektor.size());
		
		
		// es sind alle dateien schon verndert beim drop, also muss beim lschen nix mehr verndert werden
	}
	
	public void resetter() // TODO zum berprfen jumppunkt
	{
		rb111.setSelected(true);
		mp3Listener.itemStateChanged(mpe);
    	deli1.setSelected(true);
    	deli2.setSelected(false);
    	
    	if(umschalter==1)
    	{
    		// beim Reset sollte auch der einszwodreievent nochmal durchlaufen
        	listener123.itemStateChanged(einszwodrei);
    	}    	
	}
	
/* 
 * ====================== Functions for editing the filenames ==========================
 */
	
	public String lowerCase(String names)
	{
		String str = names.toLowerCase();
		
		return str;
	}	
	public String upperCase(String names)
	{
		String str = names.toUpperCase();
		
		return str;
	}
	public String dashes(String names)
	{
		String str = names.replaceAll("-"," - "); 
		
		return str;
	}
	public String whitespaces(String names)
	{
		String str = names.replaceAll("\\s+"," "); 
		String str2 = str.trim(); // trim() deletes whitespace at beginning of filename
		
		return str2;
	}	
	public String quotes(String names)
	{
		String str = names.replace("","'");
		String str2 = str.replace("`","'");
		
		return str2;
	}
	public String underscores(String names)
	{
		String str = names.replaceAll("\\_+"," ");
		
		if(str.equals(" ")) //teste ob der gesamte name nur noch aus 1 leerzeichen besteht
		{
			str = "0"; // returned den string "0", als zeichen, dass dateiname gelscht wre
		}
		return str;			
	}	
	public String numbers(String names)
	{
		StringBuffer sb = new StringBuffer(names);
		int laenge = sb.length();
		
		try{
			for(int k=0;k<laenge;k++)
			{			
				if(Character.isLetter(sb.charAt(k))!= true)
				{
					sb.deleteCharAt(k);	
					/*
					 * You must subtract the amount of numbers in the loop depending on
					 * the amount of characters you will delete.
					 * Example: You want to kill the Number '1' of the Word "1-Hallo"
					 * => k is 7 characters => if you kill one character (-Hallo), the
					 * length of k is only 6 chars => you must decrease k too
					 * else => IndexOutOfBoundsException
					 */							
					k = k-1;
				}						
				else
					break;
			}		
			String str = sb.toString();
			
			return str;
		}
		catch(Exception leerername)
		{
			return "0"; //returned "0" als zeichen dass der dateiname gelscht wre
		}
	}	
	public String delleft(String names)
	{
		String zahl = cbxm1.getSelectedItem().toString();
		int anzahl_Stellen = Integer.parseInt(zahl); 
	
		// create Characterfilter
		StringBuffer sb = new StringBuffer(names);
		String str = sb.replace(0,anzahl_Stellen,"").toString(); // kills first 1-9 characters on the left side; repeatable
		
		if(str.equals(""))
		{
			str = "0"; // falls der dateiname ganz gelscht wird, soll immer eine "0" dastehen
		}
		
		return str;
	}	
	public String delright(String names)
	{
		String zahl = cbxm1.getSelectedItem().toString();
		int anzahl_Stellen = Integer.parseInt(zahl); 

		// create Characterfilter
		StringBuffer sb2 = new StringBuffer(names);
		StringBuffer niuw = sb2.reverse(); // reverse filename: hallo.dat => tad.ollah
		
		String str;
		
		try // fr den fall dass man von rechts mehr weglscht als der dateiname lang ist
		{
			// delete from the 4th character from left, in order to save the fileextension
			str = niuw.replace(4,(anzahl_Stellen+4),"").toString(); 
			StringBuffer rev = new StringBuffer(niuw);
			str = rev.reverse().toString(); // reverse filename once again, so the filename displays correctly
		}
		catch(Exception ausserhalb)
		{
			str = "0"; // zumindest kommt jetzt keine exception mehr, und es wird eine "0" ausgegeben statt
		}
		return str;
		
	}
	public String setartist(String names)
	{
		String artistname = artistfield.getText();
		String str = artistname+" - "+names;
		
		return str;
	}	
	public String trimit(String names)
	{
		String buff = new StringBuffer(names).reverse().toString(); // reverse name
		String str;
		int index = names.lastIndexOf('.'); // get last point
		int index2 = buff.indexOf('.'); // get first point of reversed string
		String extension = null;
		String phrase = null;
		if ((index != -1)&&(index2 != -1))	// if file has extension split 
		{
			extension = "." + names.substring(index+1,buff.length()).trim(); //reads substring from last point(.) = extension
			phrase = new StringBuffer(buff.substring(index2+1,buff.length())).reverse().toString().trim();// reads substring from first point(.), when filename is reversed = filename
			str = phrase + extension;
			
			return str;
		}
		else
		{
			str = names.trim();
			
			return str;			
		}
	}
	public String redash(String names)
	{
		try
		{
			//Scanner scanner = null;
			String parts[] = null;
			String[] partsi = null;
			String parzival = "";
			
			
			// bringt jede verkackte form: '[asd- f] - [fg- fg - g].mp3' in '[asd-f] - [fg-fg-g].mp3' form 
			if(deli1.isSelected() == true)
			{		
				parts = names.split(" - "); // zuerst alle splitten um eine anzahl teile zu bekommen
				
				for(int j=0;j<parts.length;j++) // fr jeden durch " - " getrennten teile
				{								// soll er die darin vorkommenden teile
					partsi = parts[j].split("-"); // die nochmal durch "-" getrennt sind
					for(int i=1;i<partsi.length;i++) // in dieser funktion wieder zusammenfgen 
					{						// diesmal nur durch 1 strich '-' getrennt!
						partsi[0] = partsi[0].trim()+ "-" + partsi[i].trim();
					}
					if(parzival=="")
					{
						parzival = partsi[0]; // damit filename nicht ist: "null - asd-f - fg-fg-fg"
					}
					else
					{
						parzival=parzival+" - "+partsi[0]; // man erhlt alle teile durch " - " getrennt
					}
				}
								
				// nun splitten und ab dem 2. teil alle restlichen wieder zusammenfgen, parts[0] ist artist, parts[1] ist title
				parts = null;
				parts = parzival.split(" - ");
				if(parts.length>2)
				{					
					for(int i=2;i<parts.length;i++)
					{
						parts[1] = parts[1].trim()+ "-" + parts[i].trim(); 
					}
				}
				
			}
						
			else if(deli2.isSelected() == true)
			{
				parts = names.split("-");
				if(parts.length>2)
				{					
					for(int i=2;i<parts.length;i++)
					{
						parts[1] = parts[1].trim()+ "-" + parts[i].trim(); 
					}
				}
			}
			
			// combines all other parts which are split to a single part
			// and puts a single '-' in between the parts 
			
			// therefore we *must* have a result which is artist - title-etc-etc.mp3
			
			String art = parts[0].trim();	// deletes empty spaces behind and at the beginning of artist
			String tit = parts[1].trim();	// deletes empty spaces behind and at the beginning of title
			
			String str = art+" - "+tit; // return with " - " letter, so it can be divided when execute
			
			return str;
		}
		catch(Exception scannere)
		{
			// System.out.println("Error: Filename does not match pattern!");
			return names; // return old names unchanged
		}
	}
	public String swap(String names)
	{
		try
		{
			//Scanner scanner = null;
			String parts[] = null;
			
			if(deli1.isSelected() == true)
			{		
				parts = names.split(" - ");
			}
			else if(deli2.isSelected() == true)
			{
				parts = names.split("-");
			}
			
			// combines all other parts which are split to a single part
			// and puts a '-' in between the parts 
			if(parts.length>2)
			{
				for(int i=2;i<parts.length;i++)
				{
					parts[1] = parts[1].trim()+ "-" + parts[i].trim(); 
				}
			}
			
			int index = parts[1].lastIndexOf('.');
			String extension = null;
			if (index != -1)	// file has extension (e.g. .mp3,.gz,.ai,.divx - depends on last Index of a '.')
			{
				extension = "." + parts[1].substring(index+1,parts[1].length()).trim(); // get fileextension and trim if necessary e.g.: 'name. mp3'
				
				String buff1 = new StringBuffer(parts[1]).reverse().toString();	// 'akon feat. titlename.mp3' => '3mp.emaneltit .taef noka'
				String buff2 = buff1.substring(buff1.indexOf('.')+1);			// substring is: emaneltit .taef noka
				String buff3 = new StringBuffer(buff2).reverse().toString();	// reverse to: akon feat. titlename
				
				String art = parts[0].trim();	// deletes empty spaces behind and at the beginning of artist
				String tit = buff3.trim();		// deletes empty spaces behind and at the beginning of title
				
				String str = tit + " - " + art + extension; // swap artist and title
				
				return str;
			}
			else	// file has NO extension (e.g. folders)
			{
				String art = parts[0].trim();	// deletes empty spaces behind and at the beginning of part1
				String tit = parts[1].trim();	// deletes empty spaces behind and at the beginning of part2
				String str = tit + " - " + art;
				
				return str;				
			}				
		}
		catch(Exception scannere)
		{
			// System.out.println("SWAPError: Filename does not match pattern!\n");
			return names;
		}
	}
	
/* 
 * ====================== End Functions ==========================
 */
	
	public String filenametotag(String names)
	{
		try
		{
			if(!(names.endsWith("mp3") || names.endsWith("MP3")))
			{
				//return null;
				return "Error: Filename does not match pattern!";
			}
			else
			{
				// in order to work, it MUST receive a filename with the pattern "Artist - Title.mp3"
				// it must ONLY contain 2 parts!!! that must be divided by a " - "
				// highly recommended, that name is styled before using this
				//Scanner scanner = null;
				String parts[] = null;
				
				if(deli1.isSelected() == true)
				{		
					parts = names.split(" - ");
				}
				
				String buff1 = new StringBuffer(parts[1]).reverse().toString();
				String buff2 = buff1.substring(4);		// reads from the 4th position from right (extension!!!)	
				String buff3 = new StringBuffer(buff2).reverse().toString();
					
				String art = parts[0].trim();	// deletes empty spaces behind and at the beginning of artist
				String tit = buff3.trim();		// deletes empty spaces behind and at the beginning of title
							
				return art+" - "+tit; // return with " - " letter, so it can be divided when execute
				// therefore we *must* have a result which is artist - title-etc-etc
			}
		}
		catch(Exception scannere)
		{
			//return null;
			return "Error: Filename does not match pattern!";
		}
	}
	public String tag1tofilename(File uberfiles)
	{
		String[] artisttitle = new String[2];
		String origname = uberfiles.getName();
		
		try // tests if id3v1 is activated or if it's a mp3 file => else Exception
		{
			MediaFile media = new MP3File(uberfiles);
			ID3V1Tag id3v1 = media.getID3V1Tag();
			
			String artist = id3v1.getArtist();
			String title = id3v1.getTitle();
			if(artist.contentEquals("") || title.contentEquals("")) // if fields empty return null
			{
				return "Error: No ID3v1 available / Incomplete or no MP3-File!";
			}
			else // return artist and title
			{
				artisttitle[0] = artist;// insert artist into array
				artisttitle[1] = title;	// insert title into array	
				
				return artist+" - "+title;
			}
		}
		catch(Exception eeee)
		{
			return "Error: No ID3v1 available / Incomplete or no MP3-File!";
		}
	}
	public String tag2tofilename(File uberfiles)
	{
		String[] artisttitle = new String[2];
		String origname = uberfiles.getName();
		
		try // tests if id3v2 is activated or if it's a mp3 file => else Exception
		{
			MediaFile media = new MP3File(uberfiles);
			ID3V2Tag id3v2 = media.getID3V2Tag();
			
			String artist = id3v2.getArtist();
			String title = id3v2.getTitle();
			if((artist==null) || (title==null)) // if fields empty return null
			{
				return "Error: No ID3v2 available / Incomplete or no MP3-File!";
			}
			else // return artist and title
			{
				artisttitle[0] = artist;// insert artist into array
				artisttitle[1] = title;	// insert title into array	
				
				return artist+" - "+title;
			}
		}
		catch(Exception eeee)
		{
			return "Error: No ID3v2 available / Incomplete or no MP3-File!";
		}
	}
	

	
/*
 * Helpers:
 * replaceAll() replaces all whitespaces in a row with solely 1 new single character
 * replace() replaces *each* whitespace with a new character
 * 
 * MP3:
 * to check, if an ARTIST or TITLE -field is empty you must use
 * for Tag_v1: if(id3_v1.getArtist().contentEquals(""))
 * for Tag_v2: if(id3_v2.getArtist() == null)
 *  
 * TODO List:
 * nur die bugs beheben, die sonst drin sind:
 * 
 * 1. man sollte nix drcken knnen, wenn er mp3 sucht
 * 2. nix drcken a) whrend er mp3 tags holt und b) wenn execute ist
 *  => auch "Go" und "reload" und "clear" deaktivieren am besten solange bis stop gedrckt wird oder schleife fertig ist
 * 
 * der gesamte rest scheint zu passen !!! =3 =) :-)
 * 
 */
	
	
	
	class CMeinWindowLauscher extends WindowAdapter
	{
		public void windowClosing(WindowEvent we)
		{
		    System.exit(0);
		}
	}
	
	public static void main(String[] args)
	{
		
		try {
			UIManager.setLookAndFeel("com.pagosoft.plaf.PgsLookAndFeel");
			// Is your UI already created? So you will have to update the component-tree
			// of your current frame (or actually all of them...)
		} catch(Exception e) { //Most of the time you're just going to ignore it
		 }
	
		PlafOptions.setAsLookAndFeel();
		PlafOptions.updateAllUIs();
		
		Font standardfont = new Font("Arial",Font.PLAIN,12);
		
		UIManager.put("Button.font",standardfont);
		UIManager.put("Panel.font",standardfont);
		UIManager.put("CheckBox.font",standardfont);
		UIManager.put("RadioButton.font",standardfont);
		UIManager.put("TabbedPane.font",standardfont);
		UIManager.put("ComboBox.font",standardfont);
		UIManager.put("TextArea.font",standardfont);
		UIManager.put("TextPane.font",standardfont);
		UIManager.put("TextField.font",standardfont);
		UIManager.put("Menu.font",standardfont);
		UIManager.put("MenuItem.font",standardfont);
		UIManager.put("MenuBar.font",standardfont);
		UIManager.put("List.font",standardfont);
		UIManager.put("CheckBoxMenuItem.font",standardfont);
		
		//PgsLookAndFeel options
		UIManager.put("ComboBox.selectionBackground",new Color(242,220,68));
		UIManager.put("glow",new Color(255,234,0));
		UIManager.put("ProgressBar.innerGradientStart",new Color(255,255,255));
		UIManager.put("ProgressBar.innerGradientEnd",new Color(59,124,255));
		UIManager.put("ToolBar.gradientEnd",new Color(227,227,227));
		UIManager.put("ToolBar.gradientStart",Color.WHITE);
		UIManager.put("ToolBar.border",Boolean.TRUE);
		UIManager.put("ToolBarButton.selectedGradientStart",Color.WHITE);
		UIManager.put("ToolBarButton.selectedGradientEnd",Color.WHITE);
		UIManager.put("ToolBarButton.rolloverGradientStart",Color.WHITE);
		UIManager.put("ToolBarButton.rolloverGradientEnd",Color.WHITE);
		UIManager.put("ToolBarButton.isFlat",Boolean.TRUE);
		UIManager.put("Tooltip.gradientStart",new Color(0xffffa7));
		UIManager.put("Tooltip.gradientEnd",new Color(0xffffa7));
		UIManager.put("ScrollBar.width", new Integer(15));
		
		CopyOfTouch5 nebrog = new CopyOfTouch5();
		nebrog.setTitle("TouchMP3");
		//nebrog.pack();
		nebrog.setMinimumSize(new Dimension(480,705));
		nebrog.setSize(800,705);
		nebrog.setResizable(true);
		nebrog.setLocationRelativeTo(null);
		nebrog.setVisible(true);
	}
}